#! /bin/bash

# ========================================================================
# 
# Runs the AGAW runner in an endless loop.
# You should "kill -9" this script to exit the loop :-)
# 
# This process is expected to run for 1 hour: 120 iterations of 30 
# seconds each.
#
# ========================================================================
# ATTENTION: please make sure your SERVLET jar matches the one that ships 
#            with your servlet container (names may differ).
# ========================================================================

JAVA=/usr/local/queuemetrics/java/bin/java
VMOPTS="-server -Xmx256M -Xms256M"

USER=agawrunner
PASS=agaw123
JDBC="jdbc:mariadb://127.0.0.1/queuemetrics?user=queuemetrics&password=javadude&sessionVariables=sql_mode=''&autoReconnect=true"
QMPATH=/usr/local/queuemetrics/tomcat/webapps/queuemetrics
ITER=120
IDLE=30000
RUNLOG=false
RUNLOGDIR=/var/log/agaw/runner

MYSQLJAR=/usr/share/java/mysql-connectorj-current.jar
SERVLET=/usr/local/queuemetrics/tomcat/lib/servlet-api.jar

# ---------- User-configurable parameters end here ------
 
ALLCFG="-Dagaw.user=$USER -Dagaw.password=$PASS -Dagaw.jdbc=$JDBC -Dagaw.qmInstance=$QMPATH -Dagaw.nLoops=$ITER -Dagaw.idle=$IDLE -Dagaw.runlog=$RUNLOG -Dagaw.runlogdir=$RUNLOGDIR"

QMCLASS=$QMPATH/WEB-INF/classes
JARLIB=$QMPATH/WEB-INF/lib

QMARCH=$JARLIB/@@ARCHVERSION@@
QMJAR=$JARLIB/QueueMetrics-@@QMVERSION@@.jar
REDRPC=$JARLIB/redstone-xmlrpc-1.1.1.jar
SLFAPI=$JARLIB/slf4j-api-1.6.3.jar
SLFJAV=$JARLIB/slf4j-jdk14-1.6.3.jar

CP=$QMCLASS:$QMJAR:$QMARCH:$REDRPC:$MYSQLJAR:$SERVLET:$SLFAPI:$SLFJAV

function checkPath {
        if [ ! -f $1 ]
        then
            echo Missing file: $1 - stopping
            exit
        fi
}

#checkPath $QMJAR
#checkPath $JAVA
#checkPath $QMARCH
#checkPath $REDRPC
#checkPath $MYSQLJAR
#checkPath $SERVLET
#checkPath $SLFAPI
#checkPath $SLFJAV
checkPath $QMPATH/WEB-INF/agaw.properties

# dynamic classpath
CP=$(ls -a $JARLIB/*.jar | sed -e :a -e '$!N; s/\n/:/; ta')
CP=$CP:$QMCLASS:$MYSQLJAR:$SERVLET

while true;
	do $JAVA $ALLCFG $VMOPTS  -cp $CP it.loway.app.queuemetrics.agaw.QueueRunner ;
done


# ========================================================================
# $Log$
#


 

