<%@ page language="java" %>
<%@page pageEncoding="UTF-8"%>
<%@ page import="it.loway.tpf.*" %>
<%@ page import="it.loway.tpf.common.containers.*" %>
<%@ page import="it.loway.tpf.common.exceptions.*" %>
<%@ page import="it.loway.app.queuemetrics.*" %>
<%@ page import="it.loway.tpf.common.containers.LDecoder" %>
<%@ page import="it.loway.app.queuemetrics.html.WizardNavigationBar" %>
<%@ page import="it.loway.app.queuemetrics.jdbcTester.jdbcTester" %>
<%@ page import="it.loway.app.queuemetrics.jdbcTester.dbtestWizard" %>

<%@ include file="/includes/00_page_header_context.jspf" %>

<%
    // $Id: dbtestWizard1.jsp,v 1.2 2015/09/28 08:41:16 marcos Exp $

    // -- This is the starting point for the database updater wizard --

    // Start the Wizard Navigation Bar
    oDec.load( "dbtest_wznavbar", "dbtest_wzNavBar.txt", 0, 1 );
    WizardNavigationBar wzNavBar = new WizardNavigationBar(oDec, "dbtest_wznavbar");

    boolean bSucceded = oC.getS("DBTEST_OperationStatus").equalsIgnoreCase("OK");
    boolean showResults = true;

    // Define next step
    int nextHopID = (bSucceded)? dbtestWizard.STEP_OPTIMIZE : dbtestWizard.STEP_BACKUP;
    String nextHop = "dbtest_Wizard.do?StepID_" + Integer.toString(nextHopID);

    // Take results if required
    LTable ltDBTestResult = null;
    if (showResults)
        ltDBTestResult = oC.getLt("DBTEST_OperationResult");
%>

<%@ include file="dbupdateHeader.jsp" %>

    <div >
        <h1>JDBC connection tester</h1>
    </div>

    <div align="center">
        <%=wzNavBar.RenderHTML(0)%><p/>
        <hr width="50%" color="grey">
    </div>

    <div >
        <% if (bSucceded) { %>
            <div class="uk-text-success">Your database is up to date for this version of <%=CS.QUEUEMETRICS%>.</div>
        <% } else { %>
            <div class="uk-text-warning">Your database needs updating to run this version of <%=CS.QUEUEMETRICS%>.</div>
        <% } %>
    </div>


    <div >
        <form>
          <div class="uk-text-center">
            <input onclick="window.location='<%=nextHop%>'" type=button value="Next >">
          </div>
        </form>
    </div>

    <% if (showResults) { %>
        <div >
            The following tests were performed:
            <p/>
            <div>
                <%
                    SmartTable T = new SmartTable("x", ltDBTestResult);
                    T.setDecoder(oDec);
                    T.addColumn(oDec.k("td_dbtest_wz_testname"), jdbcTester.TESTNAME_COL, "300");
                    T.addColumn(oDec.k("td_dbtest_wz_testresult"), jdbcTester.TESTRESULT_COL, "80");
                    T.addColumn(oDec.k("td_dbtest_wz_testerror"), jdbcTester.TESTRESULT_ERROR, "400");

                    T.withTableClass( "qm-table uk-table uk-table-small uk-table-divider uk-table-striped uk-table-hover uk-width-expand" );
                    out.println(T.render());
                %>
            </div>
            <p/>
        </div>
    <% } %>

<%@ include file="dbupdateFooter.jsp" %>
<%
    // $Log: dbtestWizard1.jsp,v $
    // Revision 1.2  2015/09/28 08:41:16  marcos
    // jsp/jspf refactoring.
    //
    // Revision 1.1  2009/03/03 15:38:32  marcos
    // #375: dbTest refactor
    //
%>
