<%@ page language="java" %>
<%@ page import="it.loway.tpf.*" %>
<%@ page import="it.loway.tpf.common.containers.*" %>
<%@ page import="it.loway.tpf.common.interfaces.*" %>
<%@ page import="it.loway.tpf.common.exceptions.*" %>
<%@ page import="it.loway.tpf.presentation.html.*" %>
<%@ page import="it.loway.tpf.presentation.html.decorators.*" %>
<%@ page import="it.loway.app.queuemetrics.asterisk.manager.*" %>

<%@ include file="/includes/00_page_header.jspf" %>
<%
    //$Id: mgr.jsp,v 1.6 2015/09/28 08:41:17 marcos Exp $
    //
%>
<script defer>
function onLoadApplicativo() {
	// transazione standard
	document.forms[0].<%= K.REQ_VERBO %>.value = "";
	document.forms[0].<%= K.REQ_PARAM %>.value = "";
        document.forms[0].action = "mgr.jsp";
        document.forms[0].method = "GET";

}
</script>


<%
    String stAstServer = request.getParameter("server");
    String stChannel   = request.getParameter("chan");
    String stVariable  = request.getParameter("var");

    if ( stAstServer == null ) {
        stAstServer = "tcp:dial:bingo@10.10.3.5:5038" ;
    }

    if ( stChannel == null ) {stChannel = ""; }
    if ( stVariable== null ) {stVariable= ""; }

%>

		<div class="qm-form-body">
			<fieldset class="qm-fieldset">
			<legend>Querying an Asterisk server through the manager API</legend>
			<div class="qm-form-grid-3 uk-child-width-1-3@s uk-margin-top" uk-grid>
				<label for="">Asterisk server:</label>
				<div><input type="text" name="server" value="<%= stAstServer %>" ></div>

				<label for="">Channel:</label>
				<div><input type="text" name="chan" value="<%= stChannel%>" ></div>

				<label for="">Variable:</label>
				<div><input type="text" name="var" value="<%= stVariable%>" ></div>

				<div class="uk-width-1-1 uk-margin-medium-top uk-text-center">
					<input type="hidden" name="rnd"    value="<%= U.getRandomString(9) %>">
			    <input type="submit"               value="Run">
				</div>
			</div>
			</fieldset>
		</div>

<%--
    <table>
        <tr><td>
                Asterisk server:
            </td><td>
                <input type="text"   name="server" value="<%= stAstServer %>" style="width: 400px;">
        </td></tr>
        <tr><td>
                Channel:
            </td><td>
                <input type="text"   name="chan"   value="<%= stChannel   %>" style="width: 400px;">
        </td></tr>

        <tr><td>
                Variable:
            </td><td>
                <input type="text"   name="var"    value="<%= stVariable  %>" style="width: 400px;">
        </td></tr>
    </table>
    <input type="hidden" name="rnd"    value="<%= U.getRandomString(9) %>">
    <input type="submit"               value="Run">
--%>
    <hr>

<%
    if ( stAstServer.length() > 0   ) {
        AstManager a = new AstManager();
        try {

            a.connectFromUri( stAstServer );
            out.println( "<br>Querying server:" + stAstServer + "<br>");

            a.sendCommand( MgrAction.QueueStatus() );
            //out.println("<h1>Queue Status</h1><pre>" + a.getResponse() + "</pre><hr>");
            out.println( a.getBlockAsHtml( "QueueParams" ) );
            out.println( a.getBlockAsHtml( "QueueMember" ) );
            out.println( a.getBlockAsHtml( "QueueEntry" ) );


            a.sendCommand( MgrAction.Agents() );
            //out.println("<h1>Agents</h1><pre>" + a.getResponse() + "</pre><hr>");
            out.println( a.getBlockAsHtml( "Agents" ) );

            a.sendCommand( MgrAction.Status() );
            //out.println("<h1>Status</h1><pre>" + a.getResponse() + "</pre><hr>");
            out.println( a.getBlockAsHtml( "Status" ) );

            if ( !stAstServer.startsWith("file") ) {
                a.sendCommand( MgrAction.Queues() );
                out.println("<h1>Queues</h1><pre>" + a.getResponse() + "</pre><hr>");
            }

            if ( (stChannel.length() > 0)  && ( stVariable.length() > 0 )  ) {
                String stRes = a.readVar( stChannel, stVariable );
                out.println( "<font color='red'>");
                out.println( "Querying variable " + stVariable + " on channel " + stChannel +"");
                out.println( " - value: '<b>" + stRes + "</b>'" );
                out.println( "</font>");

            }

    //            MgrAction m = MgrAction.Originate( "Local/12@queuemetrics/n", "10", "queuemetrics", "", "");
    //            m.addVar( "QM_AGENT", "103");
    //            a.sendCommand( m );

            a.sendCommand( MgrAction.LogOff() );
            a.disconnect();
        } catch ( TechException e ) {
            out.println( "<h2>Error:</h2>");
            out.println( "<pre>" + U.stringifyException(e) + "</pre>" );

        }
    }
%>
<%@ include file="/includes/00_page_footer.jspf" %>
<%
// $Log: mgr.jsp,v $
// Revision 1.6  2015/09/28 08:41:17  marcos
// jsp/jspf refactoring.
//
// Revision 1.5  2008/05/12 10:09:32  lenz
// Modifiche per consentire l'uso di tracce preregistrate (vedi bug #322)
//
// Revision 1.4  2007/08/18 08:12:55  lenz
// Bug #183: doppia specifica dell'encoding
//
// Revision 1.3  2007/04/12 16:59:53  lenz-mobile
// Bug #86 - manager parametrico.
//
// Revision 1.2  2007/04/05 21:02:45  lenz
// no message
//
// Revision 1.1  2007/03/28 22:41:43  lenz
// Prima versione, solo di prova....
//
//
%>
