// $Id: custom_report.js,v 1.1 2015/09/29 13:11:44 marcos Exp $
//
// Here are the pure javascript functions (i.e. does not contain anything
// about context, label decoder and so on.

function initPage() {

    for ( var i=1; i<=7 ; i++) {
        $("#checkbox_CODA_F_noncont_day_" + i).change(function() {
            setDays();
        });
    }

    $("#CODA_dtInizio_date").datepicker( { dateFormat: 'yy-mm-dd' } );
    $("#CODA_dtFine_date").datepicker( { dateFormat: 'yy-mm-dd' } );

    $("#CODA_F_callskills_dd").change(onSkillChange);
    $("#callskill_value").keyup(onSkillChange);
    updateSkillsTable();

    saveQueryOnLoad();

    // enable/disable date pickers and set up the observer
    onTimePeriodChange();
    $( "#CODA_dtPeriod").change( onTimePeriodChange );
};

function setDays() {
    var days = "";
    for ( var i=1; i<=7 ; i++) {
        var v = $("#checkbox_CODA_F_noncont_day_" + i).attr( "checked" );

        //days += "I:" + i + "=" + v;
        if ( v == true  ) {
            days += "" + i;

        }
    }
    $("#CODA_F_noncont_days").val( days );
}


function onSkillChange() {

    // Dropdown
    var code = $('#CODA_F_callskills_dd :selected').val();

    // Value
    var valueValid = true;
    var value = $("#callskill_value").val();
    if ((value.length === 0) || isNaN(value)) {
        valueValid = false;
    }
    updateSkillsButtonsStatus((code.length !== 0) && valueValid);
}


function getSelectedSkills() {

        var result = [];
        var str = $("#CODA_F_callskills").val();
        str = $.trim(str);
        items = str.split("|");
        $.each(items,
                function(index, value) {
                    var re = /\((.+),(\d+)\)/;
                    var m;
                    if ((m = re.exec(value)) !== null) {
                        if (m.index === re.lastIndex) {
                            re.lastIndex++;
                        }
                        var skillCode = m[1];
                        var skillValue = m[2];

                        result[skillCode] = skillValue;
                    }
                }
        );

        return result;
}

function setSelectedSkills(skillPairs) {

    var tmpList = [];
    for (var key in skillPairs) {
        var value = skillPairs[key];
        if (key.length > 0 ) {
            var filterValue = '(' + key + ',' + value + ')';
            tmpList.push(filterValue);
        }
    }

    var joinedSkills = tmpList.join("|");
    console.log( "Current skills", joinedSkills);
    return joinedSkills;
}

function getSelectedSkillsCodes(skillPairs) {

    var result = [];
    for (var key in skillPairs) {
        result.push(key);
    }

    return result;
}

function getSkillValue() {

        var value = $("#callskill_value").val();
        if ((value.length === 0) || isNaN(value)) {
            value = 0;
        }

        return value;
}

function onAddSkill() {

        console.log("Adding skill");

        var code = $('#CODA_F_callskills_dd :selected').val();
        var items = getSelectedSkills();
        var itemsCode = getSelectedSkillsCodes(items);
        var skillValue = getSkillValue();

        if ($.inArray(code, itemsCode) === -1) {
            items[code] = skillValue;
            var str = setSelectedSkills(items);
            $("#CODA_F_callskills").val(str);
            updateSkillsTable();
        }
}

function onDelSkill() {

        var code = $('#CODA_F_callskills_dd :selected').val();
        var items = getSelectedSkills();
        var itemsCode = getSelectedSkillsCodes(items);

        if ($.inArray(code, itemsCode) !== -1) {
                var filtered = [];
                for (var key in items) {
                    if (key !== code) {
                        filtered[key]=items[key];
                    }
                }
                var str = setSelectedSkills(filtered);
                $("#CODA_F_callskills").val(str);
                updateSkillsTable();
        }
}

function getSkillsLabelsHash() {

        var skills = $("#CODA_F_callskills_dd option");
        var result = [];
        $.each(skills,
                function(index, value) {

                        var code = value.value;
                        var llb = value.text;

                        result[code] = llb;
                }
        );

        return result;
}

function onTimePeriodChange() {
    var tp = $('#CODA_dtPeriod :selected').val();

    var controls = $( "#CODA_dtInizio_hh" )
       .add( "#CODA_dtInizio_mm" )
       .add( "#CODA_dtInizio_date" )
       .add( "#CODA_dtFine_hh" )
       .add( "#CODA_dtFine_mm" )
       .add( "#CODA_dtFine_date" );

    // controls are enabled if tp is null or empty
    if (tp) {
        controls.attr( "disabled", "disabled" );
    } else {
        controls.removeAttr( "disabled" );
    }

}

function clear_query() {
        $("#SQUERY_name").val('');
        $("#SQUERY_secKeys").val('');
        $("#SQUERY_forAllUsers").val('');
        $("#checkbox_SQUERY_forAllUsers").removeAttr('checked');
        $("#SQUERY_type").val('REP');
        $("#SQUERY_id").val('');
        $("#SQUERY_optilock").val('');
}
