<%@ page language="java" %>
<%@ page import="it.loway.tpf.*" %>
<%@ page import="it.loway.tpf.common.containers.*" %>
<%@ page import="it.loway.tpf.common.interfaces.*" %>
<%@ page import="it.loway.tpf.common.exceptions.*" %>
<%@ page import="it.loway.tpf.presentation.html.*" %>
<%@ page import="it.loway.tpf.presentation.html.decorators.*" %>
<%@ page import="it.loway.app.queuemetrics.smartTableDecorators.*" %>
<%@ page import="it.loway.app.queuemetrics.smartTableDecorators.QA.*" %>
<%@ page import="it.loway.app.queuemetrics.caricamento.DataObjects.*" %>
<%@ page import="it.loway.app.queuemetrics.caricamento.QA.*" %>
<%@ page import="java.util.*" %>
<%
    // se non ho un contesto,
    // forza una transazione per iniziare....
    FA.startTransactionIfNoUser( request, response, "qm_start", "" );
%>
<%@ include file="/includes/00_page_header.jspf" %>
<script defer>
function onLoadApplicativo() {
	// transazione standard
	document.forms[0].<%= K.REQ_VERBO %>.value = "";
	document.forms[0].<%= K.REQ_PARAM %>.value = "";
}
</script>
<div class="qm-form-body">
    <h1><%= oDec.k("clhdr_report_details") %></h1>  
    <%
        LTable ltFilterBy = oC.getLt("QAR_FilterBySpec");
        if (ltFilterBy.numRows() != 0) {

            SmartTable T = new SmartTable( "x", ltFilterBy );
            T.setDecoder(oDec);
            //T.withCaption( );
            T.withTableClass( "qm-table uk-table uk-table-small uk-width-expand" );
            T.addSortableColumn( "" ,  0, "100",  SmartTable.SORT_NONE );
            T.addSortableColumn( "" , 1, "200",  SmartTable.SORT_NONE );
            out.println(T.render());
        }
    %>

    <h1><%= oDec.k("qa_reports_mcr_title") %></h1>

    <%
        class infoAndUsersMergerDecor implements TpfCellDecoratorInterface {

            int infoColumn = 0;
            int usersColumn = 0;
            LTable ltUsers = new LTable();

            public infoAndUsersMergerDecor (int infoColumn, int usersColumn, LTable ltUsers) {

                this.infoColumn = infoColumn;
                this.usersColumn = usersColumn;
                this.ltUsers = ltUsers;
            }

            public String decorate(LTable lt, int r, int c, String width) throws TechException {

                String infoString = lt.getS(r, infoColumn);

                if (infoString.length() != 0)
                    return "<td class='stData' style='width: " + width + ";'> " + infoString + "</td>\n";

                String stUserId = lt.getS(r, usersColumn);
                String stUserLogin = FA.decodificaDaLTable(stUserId, ltUsers, 0, 1, true);
                String stUserName = FA.decodificaDaLTable(stUserId, ltUsers, 0, 2, false);

                if (stUserName.length() != 0)
                    return  "  <td class='stData' style='width: " + width + "; color: gray;'>&nbsp;&nbsp;&nbsp;" + stUserName + " </td>\n";

                return  "  <td class='stData' style='width: " + width + "; color: gray;'>&nbsp;&nbsp;&nbsp;" + stUserLogin + "</td>\n";
            }
        }
    %>

    <h2><%= oDec.k("qa_reports_mcr_formreport") %></h2>

    <%
        LTable ltCalibrationFormReport = oC.getLt("QAR_CalibrationFormReport");
        if (ltCalibrationFormReport.numRows() != 0) {

            SmartTable T = new SmartTable( "x", ltCalibrationFormReport );
            T.setDecoder(oDec);
            //T.withCaption( );
            T.withTableClass( "qm-table uk-table uk-table-small uk-table-divider uk-table-striped uk-width-expand qm-table-withborder" );
            T.addSortableColumn( oDec.k("qa_reports_mcr_form_name"), 1, "200",  new infoAndUsersMergerDecor(0, 1, oC.getLt("DATI_users")), SmartTable.SORT_NONE);
            T.addSortableColumn( oDec.k("qa_reports_mcr_calls"), 2, "80",  SmartTable.SORT_NONE );
            T.addSortableColumn( oDec.k("qa_reports_mcr_average"), 3, "80",  SmartTable.SORT_NONE );
            T.addSortableColumn( oDec.k("qa_reports_mcr_delta"), 4, "40",  new percentDecor(100.0f).blankEmptyLines(true), SmartTable.SORT_NONE );
            T.withTableClass( "qm-table uk-table uk-table-small uk-table-divider uk-table-striped uk-width-expand qm-table-withborder" );
            out.println(T.render());
        }
    %>

    <h2><%= oDec.k("qa_reports_mcr_sectionsreport") %></h2>
    <%
        LTable ltCalibrationSectionReport = oC.getLt("QAR_CalibrationSectionReport");
        if (ltCalibrationSectionReport.numRows() != 0) {

            SmartTable T = new SmartTable( "x", ltCalibrationSectionReport );
            T.setDecoder(oDec);
            //T.withCaption( );
            T.withTableClass( "qm-table uk-table uk-table-small uk-table-divider uk-table-striped uk-width-expand qm-table-withborder" );
            T.addSortableColumn( oDec.k("qa_reports_mcr_sectionname"), 1, "200",  new infoAndUsersMergerDecor(0, 1, oC.getLt("DATI_users")), SmartTable.SORT_NONE);
            T.addSortableColumn( oDec.k("qa_reports_mcr_nitems"), 3, "50",  SmartTable.SORT_NONE );
            T.addSortableColumn( oDec.k("qa_reports_mcr_average"), 2, "80",  SmartTable.SORT_NONE );
            T.addSortableColumn( oDec.k("qa_reports_mcr_delta"), 4, "40",  new percentDecor(100.0f).blankEmptyLines(true), SmartTable.SORT_NONE );
            T.withTableClass( "qm-table uk-table uk-table-small uk-table-divider uk-table-striped uk-width-expand qm-table-withborder" );
            out.println(T.render());
        }
    %>

    <h2><%= oDec.k("qa_reports_mcr_itemsreport") %></h2>

    <%
        LTable ltCalibrationItemsReport = oC.getLt("QAR_CalibrationItemsReport");
        if (ltCalibrationItemsReport.numRows() != 0) {

            SmartTable T = new SmartTable( "x", ltCalibrationItemsReport );
            T.setDecoder(oDec);
            //T.withCaption( );
            T.withTableClass( "qm-table uk-table uk-table-small uk-table-divider uk-table-striped uk-width-expand qm-table-withborder" );
            T.addSortableColumn( oDec.k("qa_reports_mcr_code"),  0, "50",  SmartTable.SORT_NONE );
            T.addSortableColumn( oDec.k("qa_reports_mcr_question"), 1, "300",  new infoAndUsersMergerDecor(1, 2, oC.getLt("DATI_users")), SmartTable.SORT_NONE);
            T.addSortableColumn( oDec.k("qa_reports_mcr_nitems"), 4, "50",  SmartTable.SORT_NONE );
            T.addSortableColumn( oDec.k("qa_reports_mcr_average"), 3, "80",  new QANumberWithNA().markInGray(6), SmartTable.SORT_NONE );
            T.addSortableColumn( oDec.k("qa_reports_mcr_delta"), 5, "40",  new percentDecor(100.0f).blankEmptyLines(true).markInGray(6), SmartTable.SORT_NONE );
            T.withTableClass( "qm-table uk-table uk-table-small uk-table-divider uk-table-striped uk-width-expand qm-table-withborder" );
            out.println(T.render());
        }
    %>
</div>
<%@ include file="/includes/00_page_footer.jspf" %>

<%
// $Log: qaMonitorCalibData.jsp,v $
// Revision 1.9  2015/09/28 08:55:34  marcos
// jsp/jspf refactoring.
//
// Revision 1.8  2015/09/28 08:41:18  marcos
// jsp/jspf refactoring.
//
// Revision 1.7  2013/03/18 11:28:06  marcos
// IMM21 branch merge on trunk
//
// Revision 1.6  2012/11/14 15:28:32  marcos
// Rollback.
//
// Revision 1.4.2.1  2012/11/14 15:29:29  marcos
// #1762 and #1763: Non Scoring Items (QA Reports, QA Summary Report, QA Calibration Monitor)
//
// Revision 1.5  2012/11/14 15:16:40  marcos
// #1762 and #1763: Non Scoring Items (QA Reports, QA Summary Report, QA Calibration Monitor)
//
// Revision 1.4  2011/11/24 17:16:44  marcos
// #1008: Link diretto a License page
//
// Revision 1.3  2011/02/24 10:57:45  marcos
// #1248: Grader calibration- No deltas
//
// Revision 1.2  2011/01/14 11:16:50  marcos
// IMM14 merge on main trunk
//
// Revision 1.1.2.1  2010/07/15 10:28:48  marcos
// #1054: Monitor Calibration report - meta-node
//
//
%>
