<%@ page language="java" %>
<%@ page import="java.util.*" %>
<%@ page import="it.loway.tpf.*" %>
<%@ page import="it.loway.tpf.common.containers.*" %>
<%@ page import="it.loway.tpf.common.interfaces.*" %>
<%@ page import="it.loway.tpf.common.exceptions.*" %>
<%@ page import="it.loway.tpf.presentation.html.*" %>
<%@ page import="it.loway.tpf.presentation.html.decorators.*" %>
<%@ page import="it.loway.app.queuemetrics.smartTableDecorators.*" %>
<%@ page import="it.loway.app.queuemetrics.smartTableDecorators.QA.*" %>
<%@ page import="it.loway.app.queuemetrics.smartTableDecorators.tasks.*" %>
<%@ page import="it.loway.app.queuemetrics.configurazione.AgentHistory" %>
<%@ page import="it.loway.app.queuemetrics.caricamento.QA.grader.GraderHtmlHelper" %>
<%@ page import="it.loway.app.queuemetrics.caricamento.QA.perftracker.PTKCallResultsContainer" %>
<%@ page import="it.loway.app.queuemetrics.caricamento.QA.perftracker.PTKAgentsResultsContainer" %>
<%@ page import="it.loway.app.queuemetrics.caricamento.QA.perftracker.createPtkCallView.FilterTypes" %>
<%
    // se non ho un contesto,
    // forza una transazione per iniziare....
    FA.startTransactionIfNoUser( request, response, "qm_start", "" );

    String stControlsWidth = "width:150px;";
    String stNumbersWidth = "width:50px;";
    boolean moveActionsEnabled = true;
    String stSendCBTTransaction = "qm_qa_perftrack_sendcbt";
    String stSendMeetingTransaction = "qm_qa_perftrack_sendmeeting";


    class yesNoDecor implements TpfCellDecoratorInterface {
            public String decorate(LTable lt, int r, int c, String width) throws TechException {
                int inCode = lt.getI(r, c );
                String stTesto = "";
                if ( inCode != 0 ) {
                    stTesto = "<img src='../img/icons_silk/accept.png' width=16 height=16>";
                }
                return  "  <td class='stData' style='width: " + width + "; text-align: center;'>" + stTesto+ "</td>\n";
            }
    };

    class flunkedDecor implements TpfCellDecoratorInterface {
            public String decorate(LTable lt, int r, int c, String width) throws TechException {
                int inCode = lt.getI(r, c );
                String stTesto = "";
                if ( inCode != 0 ) {
                    stTesto = "<img src='../img/icons_silk/lightning.png' width=16 height=16>";
                }
                return  "  <td class='stData' style='width: " + width + "; text-align: center;'>" + stTesto+ "</td>\n";
            }
    };

    class qaFormDecor implements TpfCellDecoratorInterface {

            private LUser oU = null;
            private int clidCol = 0;
            private int agentCol = 0;
            private int tstCol = 0;
            private int queueCol = 0;
            private int callerCol = 0;
            private int formId = 0;

            public qaFormDecor(LUser oU, int clidCol, int agentCol, int tstCol, int queueCol, int callerCol, int formId) {
                this.oU = oU;
                this.clidCol = clidCol;
                this.agentCol = agentCol;
                this.tstCol = tstCol;
                this.queueCol = queueCol;
                this.callerCol = callerCol;
                this.formId = formId;
            }

            public String decorate(LTable lt, int r, int c, String width) throws TechException {
                int inCode = lt.getI(r, c );
                String stTesto = "";
                
                String callId = lt.getS(r, clidCol);
                String agent = lt.getS(r, agentCol);
                String tst = lt.getS(r, tstCol);
                String queue = lt.getS(r, queueCol);
                String caller = lt.getS(r, callerCol);
                
                if ( inCode > 0 ) {
                        stTesto = "<img src='../img/icons_silk/pencil_gray.png' width=16 height=16 onclick=\"javascript:openQAPopUpForGrading('" + callId + "','" + agent + "','" + tst + "','" + queue + "','" + caller + "','" + formId + "')\">";
                } else {
                    if (oU.hasKey("QA_TRACK")) {
                        stTesto = "<img src='../img/icons_silk/pencil_gray.png' width=16 height=16 onclick=\"javascript:openQAPopUpForGrading('" + callId + "','" + agent + "','" + tst + "','" + queue + "','" + caller + "','" + formId + "')\">";
                    }
                }
                return  "  <td class='stData' style='width: " + width + "; text-align: center;'>" + stTesto+ "</td>\n";
            }
    };
%>
<%@ include file="/includes/00_page_header.jspf" %>

<script defer>

    $(document).ready(function() {

        syncStateControls();
        addChangeEventsToStateControls();

        var element = document.getElementById("QA_PERFTRACK_filterRuleId");
        if (element) {
            element.onchange = refreshTable;
        }

    });

function refreshTable() {

    startTransaction('qm_qa_perftrack_agent_detail_bytarget', '<%= oC.getS("QA_PERFTRACK_AgentCode") %>' );
}

function _openPopUp(stUrl) {
    eval("page" + unique + " = window.open( stUrl, 'QA', '');");
}

function openQAPopUpForGrading(astclid, agent, callTst, queue, caller, formId) {
    unique = new Date().getTime();
    var parameters = "QAENV_interactionId=OK-" + callTst + "-" + astclid 
        + "&QAENV_uniqueId=" + astclid 
        + "&QAENV_callTst=" + callTst 
        + "&QAENV_agent=" + agent
        + "&QAENV_queue=" + queue
        + "&QAENV_caller=" + caller
        + "&QAENV_formId=" + formId;

    stUrl = "./qm_qa_load.do?"+parameters;
    openFullPagePopUp( stUrl );
    //_openPopUp(stUrl);
}

function openAgentTimeline(agent) {
    var parameters = "agent="+agent;

    stUrl = "qm_at_load.do?"+parameters;
    _openPopUp(stUrl);
}

function addChangeEventsToStateControls() {
    $( ".dynViewCtrls .Input" ).change( function() {
        syncStateControls();
    } );
}

function syncStateControls() {
    syncStateControl(1);
    syncStateControl(2);
    syncStateControl(3);
}

function syncStateControl( n ) {

    var obCheckBox = $( "#checkbox_QA_PERFTRACK_chk_" + n );
    var obSelector = $( "#QA_PERFTRACK_sel_" + n );
    var obValCbo   = $( "#select2-QA_PERFTRACK_valcbo_"+ n +"-container" ).parent().parent().parent();
    var obValTxt   = $( "#QA_PERFTRACK_val_" + n ).parent();

    var checked  = obCheckBox.is(':checked');
    var cboVal = obSelector.val();

    var showText = !(cboVal.indexOf( "TXT_" ) == 0 );
    var showValue = !( (cboVal.indexOf( "IS_" ) == 0 ) || (cboVal.length == 0) );

    if ( showValue ) {
        if ( showText ) {
            obValCbo.hide();
            obValTxt.show();
        } else {
            obValTxt.hide();
            obValCbo.show();
        }
    } else {
        obValTxt.hide();
        obValCbo.hide();
    }

    if ( checked ) {
        // disable row
        obSelector.attr("disabled", "disabled");
        obValCbo.attr("disabled", "disabled");
        obValTxt.attr("disabled", "disabled");
    } else {
        // enable row
        obSelector.removeAttr("disabled");
        obValCbo.removeAttr("disabled");
        obValTxt.removeAttr("disabled");
    }
}

</script>

<div class="qm-form-body">
    
    <h1><%= oDec.k("qa_perftrack_page") %>: <%= oDec.k("qa_perftrack_agentdetails") + " " + oC.getS("QA_PERFTRACK_AgentCode") %></h1>
    
    <div class="qa_perftrack">
        <%
        LTable ltHeader = oC.getLt("QA_PERFTRACK_reportHeader");
        SmartTable T = new SmartTable("x", ltHeader);
        T.setDecoder(oDec);

        T.addColumn("", 0, "150");
        T.addColumn("", 1, "150");
        %>

        <%
        // i filtri possibili
        LTable ltSel = new LTable();
        ltSel.putS(0, 0, "" );
        ltSel.putS(0, 1, "-");
        ltSel.concat( FilterTypes.permutations(oDec) );

        %>

        <%= oH.hidden( "QA_PERFTRACK_AgentCode" ) %>
        <div class="qa_perftrack-first-row">
            
            <!-- SUMMARY -->
            <%  out.println(T.render());%>
            
            <!-- FILTERS -->
            <div class="qa-perftrack-outcomes dynViewCtrls">
                <div class="ST_TRH">
                    <%= oDec.k("qa_perftrack_tot_calls") %>:  <%= oC.getLt("QA_PERFTRACK_AgentDetails").numRows() %> -
                    <%= oDec.k("qa_perftrack_visible_calls") %>: <%= oC.getLt("QA_PERFTRACK_AgentDetails_view").numRows() %>
                </div>
                <div class="ST_TR0 dynViewCtrls-row">
                    <div>
                        <%= oH.checkBox("QA_PERFTRACK_chk_1", "")%>
                    </div>

                    <div>
                        <%= oH.combo("QA_PERFTRACK_sel_1", true, stControlsWidth, ltSel, 0, 1, "")%>
                    </div>

                    <div>
                        <%= oH.textBox("QA_PERFTRACK_val_1", true, stNumbersWidth, 10)%>
                    </div>

                    <div>
                        <%= oH.combo("QA_PERFTRACK_valcbo_1", true, stControlsWidth, oC.getLt("DATI_call_status"), 0, 1, "")%>
                    </div>
                </div>
                <div class="ST_TR1 dynViewCtrls-row">
                    <div>
                        <%= oH.checkBox("QA_PERFTRACK_chk_2", "")%>
                    </div>

                    <div>
                        <%= oH.combo("QA_PERFTRACK_sel_2", true, stControlsWidth, ltSel, 0, 1, "")%>
                    </div>

                    <div>
                        <%= oH.textBox("QA_PERFTRACK_val_2", true, stNumbersWidth, 10)%>
                    </div>

                    <div>
                        <%= oH.combo("QA_PERFTRACK_valcbo_2", true, stControlsWidth, oC.getLt("DATI_call_status"), 0, 1, "")%>
                    </div>
                </div>
                <div class="ST_TR0 dynViewCtrls-row">
                    <div>
                        <%= oH.checkBox("QA_PERFTRACK_chk_3", "")%>
                    </div>

                    <div>
                        <%= oH.combo("QA_PERFTRACK_sel_3", true, stControlsWidth, ltSel, 0, 1, "")%>
                    </div>

                    <div>
                        <%= oH.textBox("QA_PERFTRACK_val_3", true, stNumbersWidth, 10)%>
                    </div>

                    <div>
                        <%= oH.combo("QA_PERFTRACK_valcbo_3", true, stControlsWidth, oC.getLt("DATI_call_status"), 0, 1, "")%>
                    </div>
                </div>
                <div class="ST_TR1">
                    <%= oH.button( oDec.k( "qa_perftrack_reload" ), true, stControlsWidth, "qm_qa_perftrack_agent_detail", oC.getS("QA_PERFTRACK_AgentCode") ) %>        
                </div>
            </div>
        </div>
            
        <!-- TASKS -->
        <div class="uk-card uk-card-body uk-card-small uk-card-default uk-width-1-1@m uk-width-1-2@l uk-border-rounded uk-align-center">
            <%@ include file="../qa/qaSendTasksForCall.jsp" %>
        </div>

        <!-- TABELLA 1 -->
        <%
            LTable lt = oC.getLt("QA_PERFTRACK_AgentDetails_view");
            T = new SmartTable("x", lt);
            T.setDecoder(oDec);
            
            T.addSortableColumn(oDec.k("qa_perftrack_tgt_score"), PTKCallResultsContainer.RESULT_SCORE_COL, "50", new QAPTKScoreDecor(PTKCallResultsContainer.RESULT_SCORECONTRIBLEGEND_COL), SmartTable.SORT_NUMBER );
            T.addSortableColumn(oDec.k("qa_perftrack_date"), PTKCallResultsContainer.RESULT_DATE_COL, "100", new timestampUnixDecor(), SmartTable.SORT_DATE_SH);
            T.addSortableColumn(oDec.k("qa_perftrack_crs_queue"), PTKCallResultsContainer.RESULT_QUEUE_COL, "100", new queueNameDecor(oC.getLt("DATI_code")), SmartTable.SORT_TEXT_CI );
            T.addSortableColumn(oDec.k("qa_perftrack_caller"), PTKCallResultsContainer.RESULT_CALLER_COL, "100", SmartTable.SORT_TEXT_CI );
            T.addSortableColumn(oDec.k("qa_perftrack_duration"), PTKCallResultsContainer.RESULT_CALLLENGTH_COL, "50", new secondDecor(), SmartTable.SORT_NUM_TEXT );
            T.addSortableColumn(oDec.k("qa_perftrack_tgt_sales"), PTKCallResultsContainer.RESULT_SALES_COL, "50", new yesNoDecor(), SmartTable.SORT_HTML_CODE );
            T.addSortableColumn(oDec.k("qa_perftrack_tgt_qc"), PTKCallResultsContainer.RESULT_QC_COL, "50", new yesNoDecor(), SmartTable.SORT_HTML_CODE );
            T.addSortableColumn(oDec.k("qa_perftrack_tgt_cont"), PTKCallResultsContainer.RESULT_CONT_COL, "50", new yesNoDecor(), SmartTable.SORT_HTML_CODE );
            T.addSortableColumn(oDec.k("qa_perftrack_tgt_avgscore"), PTKCallResultsContainer.RESULT_AVGSCORE_COL, "50", new FloatDecor(FloatDecor.MODE_NUM_1DEC), SmartTable.SORT_NUM_TEXT );
            T.addSortableColumn(oDec.k("qa_perftrack_tgt_flunked"), PTKCallResultsContainer.RESULT_FLUNKED_COL, "50", new flunkedDecor(), SmartTable.SORT_HTML_CODE);
            T.addSortableColumn(oDec.k("qatarget_outcomes"), PTKCallResultsContainer.RESULT_CALL_STATUS_COL, "100", new MultiOutcomeDecor(MultiOutcomeDecor.MODE_DECODE_CODE, oC.getLt( "DATI_call_status" )), SmartTable.SORT_TEXT_CI );
            T.addSortableColumn(oDec.k("qa_perftrack_tgt_form"), PTKCallResultsContainer.RESULT_FORMS_COL, "50", new qaFormDecor(oU, PTKCallResultsContainer.RESULT_CALLID,PTKCallResultsContainer.RESULT_AGENT_ID,PTKCallResultsContainer.RESULT_DATE_COL,PTKCallResultsContainer.RESULT_QUEUE_COL,PTKCallResultsContainer.RESULT_CALLER_COL, oC.getI("QA_PERFTRACK_form")), SmartTable.SORT_HTML_CODE);
            T.addColumn(CallSelectorDecor.decorateClearAll(), PTKCallResultsContainer.RESULT_CALLID, "50", new CallSelectorDecor());
            T.withTableClass( "qm-table uk-table uk-table-small uk-width-expand qm-table-withborder" );
            out.println(T.render());
        %>

        <!-- TABELLA 2 -->
        <%
        lt = oC.getLt("QA_PERFTRACK_AgentHistory");
        if (lt.numRows() > 0) {
        
            out.println("<p/><h3>" + oDec.k("qa_perftrack_ag_history") + "</h3>");
            T = new SmartTable("x", lt);
            T.setDecoder(oDec);
            
            T.addSortableColumn(oDec.k("qa_perftrack_date"), AgentHistory.EVENT_ADDEDTIME_COL, "100", new reformatDateDecor(reformatDateDecor.D_SHORT, U.DATA_MYSQL), SmartTable.SORT_DATE_SH);
            T.addColumn("&nbsp;", AgentHistory.EVENT_DESCRIPTION_COL, "200");
            T.addSortableColumn(oDec.k("qa_perftrack_analyst"), AgentHistory.EVENT_ADDEDBY_USERNAME_COL, "100", SmartTable.SORT_TEXT_CI);
            T.addSortableColumn(oDec.k("qa_perftrack_reason"), AgentHistory.EVENT_NOTE_COL, "150", SmartTable.SORT_TEXT_CI);
            out.println(T.render());
        }
        
        %>
    </div>
</div>
    

<%@ include file="/WEB-INF/jspf/fullPagePopup.jspf" %>

<%@ include file="/includes/00_page_footer.jspf" %>
    
    