<%@ page language="java" %>
<%@ page import="it.loway.tpf.*" %>
<%@ page import="it.loway.tpf.common.containers.*" %>
<%@ page import="it.loway.tpf.common.interfaces.*" %>
<%@ page import="it.loway.tpf.common.exceptions.*" %>
<%@ page import="it.loway.tpf.presentation.html.*" %>
<%@ page import="it.loway.tpf.presentation.html.decorators.*" %>
<%@ page import="it.loway.app.queuemetrics.caricamento.DataObjects.*" %>
<%@ page import="it.loway.app.queuemetrics.caricamento.QA.*" %>
<%@ page import="it.loway.app.queuemetrics.DO.SearchQuery"%>
<%@ page import="java.util.*" %>
<%
  // se non ho un contesto,
  // forza una transazione per iniziare....
  FA.startTransactionIfNoUser( request, response, "qm_start", "" );

%>
<%@ include file="/includes/00_page_header.jspf" %>
<div class="qm-form-body">
<%
    // inizializza Decodes
    //oDec.load( "ricerchePubbliche", "ricerchePubbliche.txt", 0, 1 );
    //oDec.load( "statusCalls", "status_calls.txt", 0, 1);

    String stWidth = "";

    // Instanzia Data  Object appropriato
    QualityAssessmentDO doQA = new QualityAssessmentDO();
    LProperties props = FA.props( application );
    doQA.initJsp( oC, oDec, oU, props, stWebHere );

    SmartTable T = null;

    // This is the QA Data Object
    QAPopupDO qaDO = new QAPopupDO();
    qaDO.initForRatingsDisplay(oC, oDec, oU);
%>

  <script defer="defer">

    var json_sources = {
      "rt_rating": <%= qaDO.renderLimitsNames() %>,
      "rt_rating_colors": <%= qaDO.renderLimitsColors() %>,
      "rt_maxv": <%= qaDO.renderLimitsRanges() %>,
      "rt_boundaries": <%= qaDO.renderRatingsBoundaries() %>,
      "rt_visibility": <%= qaDO.renderRatingsGroupsVisibilityStatus() %>,
      "rt_colors": ['red', 'darkorange', 'blue', 'green']
    }

    function onLoadApplicativo() {
      // transazione standard
      document.forms[0].<%= K.REQ_VERBO %>.value = "";
      document.forms[0].<%= K.REQ_PARAM %>.value = "";

      initEventHandlers();
      updateRatings();
      hilite();
    }

    function initEventHandlers() {

      $("input[id^=checkbox_rt_check]").bind("click", function hideShowItemsByLevel() {

        var name = this.id;
        var value = this.checked;
        var sectionNum = name.substring(name.length - 1, name.length) - 1;

        json_sources["rt_visibility"][sectionNum] = value;

        hilite();
      });
    }

    function updateRatings() {

      // Update the ratings cells
      $.map($(".ST_TR0 > td > div[id^=rt_]"), function (value) {
        var name = value.id;
        var subName = name.substring(0, name.length - 2);
        var sectionNum = name.substring(name.length - 1, name.length) - 1;
        if (subName == "rt_rating") {
          var label = json_sources[subName][sectionNum];
          if (label.length == 0) {
            label = "- - - -";
          }
          value.innerHTML = "<font color='" + json_sources[subName + "_colors"][sectionNum] + "'>" + label + "</font>";
        } else {
          value.innerHTML = json_sources[subName][sectionNum];
        }
      });

      // Update the ratings checkboxes
      $.map($("input[id^=checkbox_rt_check]"), function (value) {
        var name = value.id;
        var sectionNum = name.substring(name.length - 1, name.length) - 1;
        value.checked = json_sources["rt_visibility"][sectionNum];
      });
    }

    function hilite() {

      var items = $("td[qmvalue]");
      $.map(items, function (value) {

        var qmVal = $(value).attr('qmvalue');

        for (var i = 0; i < json_sources['rt_colors'].length; i++) {

          var minVal = json_sources['rt_boundaries'][i][0] * 100;
          var maxVal = (json_sources['rt_boundaries'][i][1] * 100) + 99;
          var color = json_sources['rt_colors'][i];
          var visibility = json_sources['rt_visibility'][i];

          if ((qmVal >= minVal) && (qmVal <= maxVal)) {
            if (visibility) {
              $(value).css('color', color);
            } else {
              $(value).css('color', 'gray');
            }
          }
        }
      });
    }
  </script>

<h2>Report Details</h2>

<div class="L-row L-justify-spacebetween L-align-flexstart">
  <div class="L-column L-flex-2">
    <div class="L-table">
    <%
                LTable ltFilterBy = oC.getLt("QAR_FilterBySpec");
                if (ltFilterBy.numRows() != 0) {
    
                    T = new SmartTable( "x", ltFilterBy );
                    T.setDecoder(oDec);
    
                    //T.withCaption( oDec.k("qa_gradings_stats") );
                    T.withTableClass( "qm-table uk-table uk-table-small" );
    
                    T.addSortableColumn( "Report Details:" ,  0, "100",  SmartTable.SORT_NONE );
                    T.addSortableColumn( "&nbsp" , 1, "200",  SmartTable.SORT_NONE );
                    out.println(T.render());
                }
    %>
    </div>
  </div>
  
  <div>
    <fieldset class="qm-fieldset">
      <div class="" uk-grid>
  
        <label for=""></label>
        <div></div>
  
        <label for=""></label>
        <div></div>
  
        <label for=""></label>
        <div></div>
  
      </div>
  
    </fieldset>
  </div>
  
  
</div>


  <h2><%= oDec.k("qa_reports") %>: <%= oDec.k("qa_summary_data") %></h2>
  <%
    T = doQA.dispatch( QualityAssessmentDO.FORM_OVERALL_SUMMARY, "" );
    T.withCaption(oDec.k("qa_reports_summary_overall") );
    T.withTableClass( "qm-table uk-table uk-table-small uk-table-divider uk-table-striped uk-width-expand qm-table-withborder" );
    out.println(T.render());
  %>
  <%= doQA.exportButtons( oDec, QualityAssessmentDO.THIS_DO, QualityAssessmentDO.FORM_OVERALL_SUMMARY ) %>

  <%
    T = doQA.dispatch( QualityAssessmentDO.SCORING_ITEMSFORM_SUMMARY, "" );
    T.withCaption(oDec.k("qa_reports_summary_scoring"));
    T.withTableClass( "qm-table uk-table uk-table-small uk-table-divider uk-table-striped uk-width-expand qm-table-withborder" );
    out.println(T.render());
  %>
  <%= doQA.exportButtons( oDec, QualityAssessmentDO.THIS_DO, QualityAssessmentDO.SCORING_ITEMSFORM_SUMMARY ) %>
  <br><small>(*)<%= oDec.k("qa_reports_note") %></small>
  <%
  T = doQA.dispatch( QualityAssessmentDO.NONSCORING_ITEMSFORM_SUMMARY, "" );
  T.withCaption(oDec.k("qa_reports_summary_nonscoring"));
  T.withTableClass( "qm-table uk-table uk-table-small uk-table-divider uk-table-striped uk-width-expand qm-table-withborder" );
  out.println(T.render());
  %>
  <%= doQA.exportButtons( oDec, QualityAssessmentDO.THIS_DO, QualityAssessmentDO.NONSCORING_ITEMSFORM_SUMMARY ) %>
  <br><small>(*)<%= oDec.k("qa_reports_note") %></small>

</div>
<%@ include file="/includes/00_page_footer.jspf" %>
<%
// $Log: qaSummaryData.jsp,v $
// Revision 1.15  2015/09/28 08:41:18  marcos
// jsp/jspf refactoring.
//
// Revision 1.14  2014/07/30 10:03:36  marcos
// #2425: Exporting a payroll report in XLS (and other formats) causes an erro
//
// Revision 1.13  2013/10/29 13:02:14  lenz-mobile
// #1913 - Custom report pages
//
// Revision 1.12  2013/10/16 09:51:56  marcos
// #2052: Changing names to QA levels
//
// Revision 1.11  2013/08/19 10:46:32  marcos
// #1914: QA: management by exception
//
// Revision 1.10  2013/08/07 09:10:28  marcos
// #1915: Overall QA Summary
//
// Revision 1.9  2013/03/18 11:28:06  marcos
// IMM21 branch merge on trunk
//
// Revision 1.8  2012/11/14 15:31:36  marcos
// Rollback.
//
// Revision 1.6.2.1  2012/11/14 15:32:10  marcos
// #1762 and #1763: Non Scoring Items (QA Reports, QA Summary Report, QA Calibration Monitor)
//
// Revision 1.7  2012/11/14 15:16:40  marcos
// #1762 and #1763: Non Scoring Items (QA Reports, QA Summary Report, QA Calibration Monitor)
//
// Revision 1.6  2012/05/09 12:39:50  marcos
// BasicDO is now always initialized with a valid LProperties.
//
// Revision 1.5  2011/12/19 09:48:04  lenz-mobile
// #1516 - Bottoni di export
//
// Revision 1.4  2011/11/24 17:16:44  marcos
// #1008: Link diretto a License page
//
// Revision 1.3  2011/01/14 11:16:50  marcos
// IMM14 merge on main trunk
//
// Revision 1.2.2.1  2010/03/12 11:28:58  marcos
// #991: N/A questions are wrongly counted in QA reports (QA Summary section average figures are now calculated with historical values)
//
// Revision 1.2  2010/01/12 17:11:54  marcos
// IMM11 branch merge on main trunk
//
// Revision 1.1.2.1  2009/12/01 17:03:46  marcos
// #902: QA REPORTS LIKE VERIZON’S
//

%>
