<%@ page language="java" %>
<%@ page import="it.loway.tpf.*" %>
<%@ page import="it.loway.tpf.common.containers.*" %>
<%@ page import="it.loway.tpf.common.interfaces.*" %>
<%@ page import="it.loway.tpf.common.exceptions.*" %>
<%@ page import="it.loway.tpf.presentation.html.*" %>
<%@ page import="it.loway.tpf.presentation.html.decorators.*" %>
<%@ page import="java.util.*" %>
<%@ page import= "it.loway.app.queuemetrics.configurazione.cfg2.ptAmoLists" %>
<%@ page import= "it.loway.app.queuemetrics.configurazione.cfg2.ptAmoNumbers" %>
<%@ page import= "ch.loway.app.queuemetrics.qap.amo.ListState" %>
<%
    // se non ho un contesto,
    // forza una transazione per iniziare....
    FA.startTransactionIfNoUser( request, response, "qm_start", "" );
%>
<%@ include file="/includes/00_page_header.jspf" %>
<%
    // inizializza Decodes
    oDec.load( "masterkeyAbilitato", "masterkey_abilitato.txt", 0, 1 );
    oDec.load( "amo_list_states", "amo_list_states.txt", 0, 1 );

    final String stVerbPrefix = ptAmoLists.TRANSACTION_PREFIX;
    final String stTabPrefix  = ptAmoLists.CONTEXT_PREFIX;
    final int primaryKey = oC.getI("TABAMO_LISTS_amo_list_id");
    oDec.load( "amo_list_states",  "amo_list_states.txt",  0, 1 );

    String stWidth = "";
%>
<%-- transazione standard --%>
<%@ include file="/includes/qm_adm/21_qm_adm_transazione_standard.jspf" %>
<script src="../thirdParty/papaparse.min.js"></script>

<script>

  window.csvImportErrorMessage = "";

  function normalizeValidFrom(date) {
    // Regular expression to match the full datetime format
    const dateTimeRegex = /^\d{4}-\d{2}-\d{2} \d{2}:\d{2}:\d{2}$/;
    // Regular expression to match the date-only format
    const dateOnlyRegex = /^\d{4}-\d{2}-\d{2}$/;

    if (dateTimeRegex.test(date)) {
      // The date string follows the full datetime format
      return date;
    } else if (dateOnlyRegex.test(date)) {
      // The date string follows the date-only format
      return date + " 00:00:00";
    } else {
      // The date string doesn't follow the above formats
      return "0000-00-00 00:00:00";
    }
  }

  function urlParams(data) {
    var formBody = []
    for (var k in data) {
      var v = data[k]
      if (v instanceof Array || v instanceof Object) {
        v = JSON.stringify(v)
      }

      var encodedKey = encodeURIComponent(k)
      var encodedValue = encodeURIComponent(v)
      formBody.push(encodedKey + "=" + encodedValue)
    }
    formBody = formBody.join("&")
    return formBody
  }

  function qmPost(url, data) {
    return fetch(url, {
      method: "POST",
      body: urlParams(data),
      credentials: "same-origin",
      headers: {
        Accept: "application/json",
        "Content-Type": "application/x-www-form-urlencoded",
      },
    })
  }

  function csvValidityCheck(fileData) {
    fileData = fileData.filter(row => row.length === fileData[0].length)
    // Check if there are at least two lines (one for headers and one for at least one record)
    if (fileData.length < 2) {
      window.csvImportErrorMessage = <%= "'" + oDec.k("amo_import_error_norecords") + "'" %>
      return false
    }

    // Get the headers (the first row)
    const headers = fileData[0];

    if (!headers.includes("number")) {
      window.csvImportErrorMessage = <%= "\"" + oDec.k("amo_import_error_nonumber") + "\"" %>
      return false
    }

    return true
  }

  function uploadFile(event) {
    event.stopPropagation();
    event.preventDefault();
    const input = document.getElementById('csvFile');
    const file = input.files[0];

    var numbers = []; // No need to redeclare this inside the if (file) block

    if (file) {
      Papa.parse(file, {
        complete: function(results) {
          const fileData = results.data.filter(row => row.length > 0);
          // var numbers = [] This declaration is redundant
          if (window.isCsvFileValid === true) {
            fileData.forEach((numberData, index) => {
              if (index > 0 && numberData.length === fileData[0].length) {
                var number = {
                  attrs: {}
                }; // Initialize number with attrs here

                numberData.forEach((element, i) => {
                  if (fileData[0][i] === "number") {
                    number["number"] = element.replace(/\D+/g, '');
                  } else if (fileData[0][i] === "valid_from") {
                    // Normalize date to YYYY-MM-DD HH:MM:SS format
                    number["validFrom"] = normalizeValidFrom(element);
                  } else {
                    // This else belongs to the above if-else chain, ensure attrs is initialized
                    if (element && element.length > 0) {
                      number.attrs[fileData[0][i]] = element;
                    }
                  }

                  if (!fileData[0].includes("valid_from")) {
                    number.validFrom = "0000-00-00 00:00:00"
                  }
                });
                numbers.push(number);
              }
            });

            const data = {
              data: {
                "amoCampaignName": <%= "'" + oC.getS(ptAmoLists.DEPENDENT_QUEUE_NAME) + "'" %> ,
                "listName": <%= "'" + oC.getS("TABAMO_LISTS_list_name") + "'" %> ,
                "numbers": numbers
              }
            }

            qmPost("./amo_upload_numbers.do", data)
              .then((response) => {
                return response.json();
              })
              .then((json) => {
                if (json.status && json.status == "OK") {
                  var modal = document.getElementById("uploadCsvModal");
                  modal.style.display="none";
                  window.UIkit.modal.dialog("<%=oDec.k("amo_upload_numbers_success")%>");
                } else {
                  window.UIkit.modal.dialog("<%=oDec.k("amo_upload_numbers_error")%>");
                }
                setTimeout(() => startTransaction('qm_cfg2_amo_lists_edit', '<%=oC.getI("TABAMO_LISTS_amo_list_id")%>'), 2000);
              })
              .catch((err) => {
                // Error handling
              });
          }
        }
      });
    }
  }
</script>

<div class="qm-form-body L-column L-gap-24">
  <div class="uk-flex uk-flex-between">
    <% out.println(LowayHtml.tertiaryButton("<span uk-icon='icon: chevron-left; ratio: 1'></span>"+oDec.k("edit_record_back"), true, stVerbPrefix + "_list", oC.getS(ptAmoLists.DEPENDENT_QUEUE_ID))); %>

    <div class="uk-flex L-gap-16">
      <% out.println(LowayHtml.secondaryButton(oDec.k("edit_record_new"), (primaryKey > 0 ), stVerbPrefix + "_edit", "N")); %>
      <% out.println(LowayHtml.secondaryButton(oDec.k("edit_record_clone"), (primaryKey > 0 ), stVerbPrefix + "_edit", "C")); %>
    </div>
  </div>

  <legend><%= oC.getS(ptAmoLists.DEPENDENT_QUEUE_NAME) %><span uk-icon="icon: chevron-right; ratio: 1"></span><%=oDec.k("edit_amo_lists_title")%></legend>

  <div class="uk-grid-large uk-child-width-1-2" uk-grid>
    <div class="left">
      <div class="uk-flex L-gap-16">
        <div class="uk-flex uk-flex-column L-gap-16 uk-flex-1">
          <div class="L-column L-gap-8">
            <label for="TABAMO_LISTS_list_name"><%= oDec.k("edit_amo_name") %></label>
            <%= oH.textBox( "TABAMO_LISTS_list_name", true, stWidth, 50 ) %>
          </div>
          <div class="L-column L-gap-8">
            <label for="TABAMO_LISTS_weight"><%= oDec.k("edit_amo_list_weight") %></label>
            <%= oH.textBox( "TABAMO_LISTS_weight", true, stWidth, 50 ) %>
          </div>
          <div class="L-column L-gap-8">
            <label for="TABAMO_LISTS_state"><%= oDec.k("edit_amo_list_state") %></label>
            <%= oH.combo("TABAMO_LISTS_state", true, stWidth, "amo_list_states", "open")%>
          </div>
        </div>
        <div class="uk-flex-1 L-column L-gap-8">
          <label for="TABAMO_LISTS_list_notes"><%= oDec.k("edit_amo_notes") %></label>
          <textarea class="L-border-radius L-height-100" style="border-radius: 8px;" id="TABAMO_LISTS_list_notes" name="TABAMO_LISTS_list_notes" cols="50"><%=oC.getS("TABAMO_LISTS_list_notes")%></textarea>
        </div>
      </div>
    </div>
    <div class="right">
      <table class="qm-table-striped uk-table">
        <tbody>
          <tr>
            <td>
              <%=oDec.k("dlr_list_state")%>
            </td>
            <td>
              <%=oDec.decode("amo_list_states", oC.getS( "TABAMO_LISTS_dlr_state" ))%>
            </td>
          </tr>
          <tr>
            <td>
              <%=oDec.k("dlr_numbers_added")%>
            </td>
            <td>
              <%= oC.getS( "TABAMO_LISTS_dlr_numbers_added" ) %>
            </td>
          </tr>
          <tr>
            <td>
              <%=oDec.k("dlr_numbers_completed")%>
            </td>
            <td>
              <%= oC.getS("TABAMO_LISTS_dlr_numbers_completed") %>
            </td>
          </tr>
          <tr>
            <td>
              <%=oDec.k("dlr_numbers_pulled")%>
            </td>
            <td>
              <%= oC.getS("TABAMO_LISTS_dlr_numbers_pulled") %>
            </td>
          </tr>
          <tr>
            <td>
              <%=oDec.k("dlr_last_pull")%>
            </td>
            <td>
              <%= oC.getS("TABAMO_LISTS_dlr_last_pull") %>
            </td>
          </tr>
          <tr>
            <td>
              <%=oDec.k("dlr_last_pull_user")%>
            </td>
            <td>
              <%= oC.getS("TABAMO_LISTS_dlr_last_pull_user") %>
            </td>
          </tr>
          <tr>
            <td>
              <%=oDec.k("edit_record_createdby")%>
            </td>
            <td>
              <%= oC.getS(stTabPrefix + "_nomedata_insert") %>
            </td>
          </tr>
          <tr>
            <td>
              <%=oDec.k("edit_record_lastupdate")%>
            </td>
            <td>
              <%= oC.getS(stTabPrefix + "_nomedata_update") %>
            </td>
          </tr>
        </tbody>  
      </table>
    </div>
  </div>

  <div class="uk-flex uk-flex-between">
    <div class="L-row L-gap-16">
        <%= oH.button( oDec.k("edit_amo_list_numbers"), (primaryKey > 0 ), "", ptAmoNumbers.TRANSACTION_PREFIX + "_list", ""+primaryKey ) %>
        <input type="button" class="Q-button-primary" <%= (primaryKey > 0 ) ? "" : "disabled" %> value=<%= "'"+oDec.k("edit_amo_list_upload_numbers")+"'" %> id="modalButton">
    </div>
    <div class="L-row L-gap-16">
    <button class="Q-button-secondary" <%=(primaryKey > 0 ) ? "" : "disabled "%> onclick=<%="deleteSingleRecord('"+stVerbPrefix+"','"+oC.getS("TABAMO_LISTS_list_name")+"','"+oC.getS("TABAMO_LISTS_amo_list_id")+"')"%>><%=oDec.k("edit_record_delete")%></button>
      <% out.println(LowayHtml.primaryButton(oDec.k("edit_record_save"), true, stVerbPrefix + "_edit",  "S")); %>
    </div>
  </div>

  <!-- The Modal -->
  <div id="uploadCsvModal" class="Q-modal">

    <!-- Modal content -->
    <div class="Q-modal-content">
      <div class="L-column L-gap-16">

        <div id="dropContainer">
          <label class="Q-upload" for="csvFile" id="csvFileLabel"><%=oDec.k("edit_amo_list_upload_text")%></label>
          <input type="file" id="csvFile" style="display: none;" accept=".csv" />
        </div>
        <div id="amoCsvFileInfo" style="display: none;" class="L-column L-gap-8">
          <div class="L-tertiary-text"><%=oDec.k("gui_fileuploader_uploaded")%></div>
          <div id="amoCsvFileName" class="L-primary-text"></div>
        </div>
        <div id="amoCsvErrorMessage" class="L-error" style="display:none;"></div>
        <button id="okButton" class="Q-button-primary L-width-100" autofocus="" onclick="uploadFile(event)" ><%=oDec.k("gui_form_ok")%></button>
      </div>
    </div>

  </div>

<%@ include file="/includes/00_page_footer.jspf" %>

<script>
  document.getElementById('csvFile')
</script>

<script>
// Get the modal
var modal = document.getElementById("uploadCsvModal");

// Get the button that opens the modal
var btn = document.getElementById("modalButton");

// When the user clicks the button, open the modal
btn.onclick = function() {
  modal.style.display = "block";
}

// When the user clicks anywhere outside of the modal, close it
window.onclick = function(event) {
  if (event.target == modal) {
    modal.style.display = "none";
  }
}

// Reference to the drop container and the file input element
const dropContainer = document.getElementById('dropContainer'); // Make sure this is the correct ID
const fileInput = document.getElementById('csvFile'); // Make sure this is the correct ID

// Prevent default behavior for 'dragover' and 'dragenter' events
const preventDefaults = (evt) => {
  evt.preventDefault();
  evt.stopPropagation();
};

// Handle the 'drop' event
const handleDrop = (evt) => {
  evt.preventDefault();
  evt.stopPropagation();

  // Using DataTransfer to handle the file input's files property
  const dT = new DataTransfer();
  for (const file of evt.dataTransfer.files) {
    dT.items.add(file); // Add all dropped files
  }

  fileInput.files = dT.files; // Update the file input with the dropped files

  // Trigger the change event on the file input
  const changeEvent = new Event('change');
  fileInput.dispatchEvent(changeEvent);
};

// Add event listeners
dropContainer.addEventListener('dragover', preventDefaults);
dropContainer.addEventListener('dragenter', preventDefaults);
dropContainer.addEventListener('drop', handleDrop);
fileInput.addEventListener('change', function(event) {
    var file = event.target.files[0];

    Papa.parse(file, {
        complete: function(results) {
          const fileData = results.data.filter(row => row.length > 0);
          window.isCsvFileValid = csvValidityCheck(fileData)
          var amoCsvErrorMessage = document.getElementById('amoCsvErrorMessage');
          var okButton = document.getElementById('okButton');
          var amoCsvFileInfo = document.getElementById('amoCsvFileInfo');
          var amoCsvFileName = document.getElementById('amoCsvFileName');
          if (!window.isCsvFileValid) {
            amoCsvErrorMessage.style.display = "block"
            amoCsvFileInfo.style.display = "none"
            amoCsvErrorMessage.innerHTML = "<div class='L-row L-gap-8'><span uk-icon='icon: warning; ratio: 1'></span> " + window.csvImportErrorMessage + "</div>";
            okButton.disabled = true
          } else {
            amoCsvErrorMessage.style.display = "none"
            amoCsvFileInfo.style.display = "flex"
            amoCsvErrorMessage.innerHTML = ''; // Clear the message if the string is empty
            okButton.disabled = false
            if(file.name){
              amoCsvFileName.innerHTML = "<div class='L-row L-justify-spacebetween'><div class='L-row L-gap-8'><span uk-icon='icon: file-text; ratio: 1'></span> " + file.name + "</div><span class='L-success' uk-icon='icon: check; ratio: 1'></div>";
            }
          }
        }
    });
  });
</script>

<!--
<label for="TABAMO_LISTS_amo_list_id"><%= oDec.k("edit_amo_list_id") %></label>
<div><%= oH.textBox( "TABAMO_LISTS_amo_list_id", true, stWidth, 50 ) %></div>

<label for="TABAMO_LISTS_amo_list_queue_id"><%= oDec.k("edit_amo_queue_id") %></label>
<div><%= oH.textBox( "TABAMO_LISTS_queue_id", true, stWidth, 50 ) %></div>
-->
