<%@ page language="java" %>
<%@ page import="it.loway.tpf.*" %>
<%@ page import="it.loway.tpf.common.containers.*" %>
<%@ page import="it.loway.tpf.common.interfaces.*" %>
<%@ page import="it.loway.tpf.common.exceptions.*" %>
<%@ page import="it.loway.tpf.presentation.html.*" %>
<%@ page import="it.loway.tpf.presentation.html.decorators.*" %>
<%@ page import="it.loway.app.queuemetrics.configurazione.QAFormInfo" %>
<%@ page import="java.util.*" %>
<%
    // Render the list of items composing a section
    class ItemsListRenderer {
        public ItemsListRenderer() {};
        public String RenderList(LTable ltItems) {
            String sResult = "<div style=\"font-size: 0.75em;\">";
            if (ltItems.numRows() > 0) {
                sResult += "(";
                for (int i = 0; i < ltItems.numRows(); i++) {
                    sResult += ltItems.getS(i, 0);
                    if (i != ltItems.numRows() - 1)
                        sResult += ", ";
                    if ((i+1)%14 == 0)
                        sResult += "<br>";
                }
                sResult += ")";
            } else {
                sResult += "No items";
            }
            sResult += "</div>";
            return sResult;
        }
    }
%>
<%
    // se non ho un contesto,
    // forza una transazione per iniziare....
    FA.startTransactionIfNoUser( request, response, "qm_start", "" );

%>
<%@ include file="/includes/00_page_header.jspf" %>
<%
    // inizializza Decodes

    oDec.load( "masterkeyAbilitato", "masterkey_abilitato.txt", 0, 1 );
    final String stVerbPrefix = "qm_cfg2_qa_forms";
    final String stTabPrefix  = "TABQA_FORMS";
    String stWidth       = "" ;
    String stWidthShort  = "" ;
//    oDec.load( "queueDirection", "queueDirection.txt", 0, 1 );
//    oDec.load( "queueDirectionImg", "queueDirection.txt", 0, 2 );
//    oDec.load( "masterkeyAbilitato", "masterkey_abilitato.txt", 0, 1 );
    ItemsListRenderer listRenderer = new ItemsListRenderer();
%>

<script>
function onLoadApplicativo() {
	// transazione standard
	document.forms[0].<%= K.REQ_VERBO %>.value = "";
	document.forms[0].<%= K.REQ_PARAM %>.value = "";
}
</script>

<div class="qm-form-body">
  <fieldset class="qm-fieldset">
    <legend><%= oDec.k("edit_record_qa_title") %></legend>

    <div class="qm-form-grid-3 uk-child-width-1-3@s" uk-grid>

      <label for="TABQA_FORMS_nome_form"><%= oDec.k("edit_record_qa_name") %></label>
      <div><%= oH.textBox( "TABQA_FORMS_nome_form",  true, stWidth, 100 ) %></div>

      <label for="TABQA_FORMS_seckey_input"><%= oDec.k("edit_record_qa_inputkey") %></label>
      <div><%= oH.textBox( "TABQA_FORMS_seckey_input",  true, stWidth, 100 ) %></div>

      <label for="TABQA_FORMS_seckey_report"><%= oDec.k("edit_record_qa_reportkey") %></label>
      <div><%= oH.textBox( "TABQA_FORMS_seckey_report",  true, stWidth, 100 ) %></div>

      <label for="TABQA_FORMS_seckey_queues"><%= oDec.k("edit_record_qa_visibility") %></label>
      <div><%= oH.textBox( "TABQA_FORMS_seckey_queues", true, stWidth, 500 ) %></div>

      <label for="TABQA_FORMS_is_locked"><%= oDec.k("edit_record_qa_locked") %></label>
      <div><%= oH.combo( "TABQA_FORMS_is_locked", true, stWidth, oC.getLt( "TABQA_FORMS_lockyesno" ), 0, 1, "n" ) %></div>

      <label for="TABQA_FORMS_howmanyrecords"><%= oDec.k("edit_record_qa_nofgradedcalls") %></label>
      <div><%= oC.getI( "TABQA_FORMS_howmanyrecords" ) %></div>
  </fieldset>

  <fieldset class="qm-fieldset">
    <legend><%= oDec.k("edit_record_qa_secnames") %></legend>
    <div class="qm-form-grid-3 uk-child-width-1-3@s" uk-grid>
      <% for (int s = 1; s <= QAFormInfo.MAX_SECTIONS; s++) {
          out.println("<label for=\"TABQA_FORMS_section_"+ s +"\">");
          out.println( oDec.k("edit_record_qa_section") + " " + s );
          out.println("</label>");

          out.println("<div>");
          out.println(oH.textBox( "TABQA_FORMS_section_" + s,  true, stWidth, 50 ));
          out.println("<br>");
          out.println(listRenderer.RenderList(oC.getLt( "TABQA_FORMS_itemslist_" + s )));
          out.println("</div>");
      } %>
    </div>
  </fieldset>


  <fieldset class="qm-fieldset L-column L-gap-24">
    <legend><%= oDec.k("edit_record_qa_grading") %></legend>
      <div class="qm-admin-callgrading uk-flex-middle uk-flex uk-child-width-1-5@s uk-margin" uk-grid>
        <% for (int i = 1; i < 5; i++) { %>
          <div  class="uk-text-right@s uk-width-1-3@s qm-qa-maxvalue-description"><%= oDec.k("edit_record_qa_maxvalue") %></div>
          <label class="uk-width-1-2@s uk-text-left uk-text-nowrap	" for="TABQA_FORMS_rating_<%=i%>" class="qm-form-second-smaller uk-text-nowrap uk-width-1-2">
            <%= oH.textBox( "TABQA_FORMS_rating_" + i + "_label",  true, stWidth, 50 ) %>
            ( <%= oH.textBox( "TABQA_FORMS_rating_" + i + "_labelshort",  true, stWidthShort, 5 ) %> )
          </label>

          <div class="qm-qa-maxvalue uk-width-1-6@s"><%= oH.textBox( "TABQA_FORMS_rating_" + i,  true, stWidthShort, 3 ) %></div>
      <% } %>
      </div>

      <div class="qm-form-grid-3 uk-child-width-1-3@s" uk-grid>
        <label for="TABQA_FORMS_nomedata_insert"><%= oDec.k("edit_record_createdby") %></label>
        <div><%= oH.textBox( "TABQA_FORMS_nomedata_insert",  false, stWidth, 100 ) %></div>

        <label for="TABQA_FORMS_nomedata_update"><%= oDec.k("edit_record_lastupdate") %></label>
        <div><%= oH.textBox( "TABQA_FORMS_nomedata_update",  false, stWidth, 100 ) %></div>
      </div>

      <div class="L-row uk-flex-between">
        <%= oH.iconButton( "<span uk-icon='icon: chevron-left; ratio: 1'></span>"+oDec.k("edit_record_back"), true, "", stVerbPrefix + "_list", "", "Q-button-tertiary") %>
        <div class="L-row L-gap-16">
          <%= oH.button( oDec.k("edit_record_new"), (oC.getI("TABQA_FORMS_form_id") > 0 ), "", stVerbPrefix + "_edit", "N", "Q-button-secondary") %>
          <%= oH.button( oDec.k("edit_record_clone"), (oC.getI("TABQA_FORMS_form_id") > 0 ), "", stVerbPrefix + "_edit", "C", "Q-button-secondary") %>
          <% boolean boCanModify = (oC.getI("TABQA_FORMS_form_id") > 0 ) && ( oC.getI( "TABQA_FORMS_howmanyrecords" ) == 0); %>
          <%= oH.button( oDec.k("edit_record_qa_editsections"), boCanModify , "", "qm_cfg2_qa_form_items", oC.getS("TABQA_FORMS_form_id"), "Q-button-secondary") %>
          <%= oH.buttonScript( oDec.k("edit_record_delete"), boCanModify, "", "deleteSingleRecord('"+stVerbPrefix+"','"+oC.getS("TABQA_FORMS_nome_form")+"','"+oC.getS("TABQA_FORMS_form_id")+"')", "Q-button-secondary") %>
        </div>
        <%= oH.button( oDec.k("edit_record_save"), true, "", stVerbPrefix + "_edit", "S" ) %>
      </div>
  </fieldset>

</div>



<%--
<center>
<h1><%= oDec.k("edit_record_qa_title") %></h1>
<table border="0" class="ST">
<!--
<tr><td>
form_id
</td><td>
<%= oH.textBox( "TABQA_FORMS_form_id",  true, "", 100 ) %>
</td></tr>
-->
<tr><td>
<%= oDec.k("edit_record_qa_name") %>
</td><td>
<%= oH.textBox( "TABQA_FORMS_nome_form",  true, stWidth, 100 ) %>
</td></tr>
<tr><td>
<%= oDec.k("edit_record_qa_inputkey") %>
</td><td>
<%= oH.textBox( "TABQA_FORMS_seckey_input",  true, stWidth, 100 ) %>
</td></tr>
<tr><td>
<%= oDec.k("edit_record_qa_reportkey") %>
</td><td>
<%= oH.textBox( "TABQA_FORMS_seckey_report",  true, stWidth, 100 ) %>
</td></tr>
<tr><td>
<%= oDec.k("edit_record_qa_visibility") %>
</td><td>
<%= oH.textBox( "TABQA_FORMS_seckey_queues", true, stWidth, 500 ) %>
</td></tr>
<tr><td>
<%= oDec.k("edit_record_qa_locked") %>
</td><td>
<%= oH.combo( "TABQA_FORMS_is_locked", true, stWidth,
              oC.getLt( "TABQA_FORMS_lockyesno" ), 0, 1, "n" ) %>
</td></tr>
<tr><td>
<%= oDec.k("edit_record_qa_nofgradedcalls") %>
</td><td>
<%= oC.getI( "TABQA_FORMS_howmanyrecords" ) %>
</td></tr>
<tr><td colspan="2" align="center">&nbsp;</td></tr>
<tr><td colspan="2" align="center">
<b><%= oDec.k("edit_record_qa_secnames") %></b>
</td></tr>
<% for (int s = 1; s <= QAFormInfo.MAX_SECTIONS; s++) {
    out.println("<tr><td>");
    out.println(oDec.k("edit_record_qa_section")+" " + s + ":");
    out.println("</td><td>");
    out.println(oH.textBox( "TABQA_FORMS_section_" + s,  true, stWidth, 50 ));
    out.println("</td></tr>");
    out.println("<tr><td>");
    out.println("&nbsp;");
    out.println("</td><td>");
    out.println(listRenderer.RenderList(oC.getLt( "TABQA_FORMS_itemslist_" + s )));
    out.println("</td></tr>");
} %>
<tr><td colspan="2" align="center">&nbsp;</td></tr>
<tr><td colspan="2" align="center">

<b><%= oDec.k("edit_record_qa_grading") %></b>
</td></tr>
<tr>
    <td colspan ="2" align="center">
    <table>
        <% for (int i = 1; i < 5; i++) { %>
        <tr><td>
        <%= oDec.k("edit_record_qa_maxvalue") %>
        </td><td>
        <%= oH.textBox( "TABQA_FORMS_rating_" + i + "_label",  true, stWidth, 50 ) %>
        </td><td>
        (
        </td><td>
        <%= oH.textBox( "TABQA_FORMS_rating_" + i + "_labelshort",  true, stWidthShort, 5 ) %>
        </td><td>
        ):
        </td><td>
        <%= oH.textBox( "TABQA_FORMS_rating_" + i,  true, stWidthShort, 3 ) %>
        </td></tr>
        <% } %>
    </table>
</td>
<tr><td colspan="2" align="center">&nbsp;</td></tr>
<tr><td>
<%= oDec.k("edit_record_createdby") %>
</td><td colspan="2">
<%= oH.textBox( "TABQA_FORMS_nomedata_insert",  false, stWidth, 100 ) %>
</td></tr>
<tr><td>
<%= oDec.k("edit_record_lastupdate") %>
</td><td colspan="2">
<%= oH.textBox( "TABQA_FORMS_nomedata_update",  false, stWidth, 100 ) %>
</td></tr>
</table>
<p>
    <%= oH.button( oDec.k("edit_record_save"), true, "", stVerbPrefix + "_edit", "S" ) %>
    <%= oH.button( oDec.k("edit_record_back"), true, "", stVerbPrefix + "_list", "") %>
    <%= oH.button( oDec.k("edit_record_new"), (oC.getI("TABQA_FORMS_form_id") > 0 ), "", stVerbPrefix + "_edit", "N") %>
    <%= oH.button( oDec.k("edit_record_clone"), (oC.getI("TABQA_FORMS_form_id") > 0 ), "", stVerbPrefix + "_edit", "C") %>
<%
    boolean boCanModify = (oC.getI("TABQA_FORMS_form_id") > 0 ) && ( oC.getI( "TABQA_FORMS_howmanyrecords" ) == 0);
%>
    <%= oH.button( oDec.k("edit_record_qa_editsections"), boCanModify , "", "qm_cfg2_qa_form_items", oC.getS("TABQA_FORMS_form_id")) %>
    <%= oH.buttonScript( oDec.k("edit_record_delete"), boCanModify, "", "deleteSingleRecord('"+stVerbPrefix+"','"+oC.getS("TABQA_FORMS_nome_form")+"','"+oC.getS("TABQA_FORMS_form_id")+"')") %>


</center>
--%>
<%@ include file="/includes/00_page_footer.jspf" %>
<%
// $Log: cfg2_qa_forms_edit.jsp,v $
// Revision 1.18  2015/09/28 08:41:12  marcos
// jsp/jspf refactoring.
//
// Revision 1.17  2014/05/19 09:46:34  lenz
// Merge FRANKIE
//
// Revision 1.16.4.1  2014/05/13 13:33:35  mirkox
// Nuova Grafica
//
// Revision 1.16  2013/10/15 16:05:16  marcos
// #2052: Changing names to QA levels
//
// Revision 1.15  2011/11/24 17:16:44  marcos
// #1008: Link diretto a License page
//
// Revision 1.14  2011/02/24 11:30:07  marcos
// #1251: QA modifiche cosmetiche
//
// Revision 1.13  2011/01/14 11:16:43  marcos
// IMM14 merge on main trunk
//
// Revision 1.12.2.1  2010/06/16 09:25:02  marcos
// #1051: Display only relevant Quality forms
//
// Revision 1.12  2010/01/12 17:11:53  marcos
// IMM11 branch merge on main trunk
//
// Revision 1.11.2.1  2009/11/18 10:54:28  marcos
// #960 - QA: Having 10 sections and 100 scores
//
// Revision 1.9  2009/08/13 10:24:23  marcos
// #800: Minor bugs on QA Items Editor page
//
// Revision 1.8  2009/07/23 10:05:36  marcos
// #660: Added items list on QA form edit
//
// Revision 1.7  2009/07/04 09:35:10  lenz-mobile
// Bug #662 - cloning dei forms
//
// Revision 1.6  2008/03/31 13:39:06  lenz
// Bug #287: regole di edit/cancellazione record.
//
// Revision 1.5  2008/03/21 11:04:22  lenz
// Typo (bug #290)
//
// Revision 1.4  2008/03/15 14:16:42  lenz
// Inseriti valori di call grading e combo y/n
//
// Revision 1.3  2008/03/14 17:31:21  lenz
// Bug #283: Campi forms come da specifica.
//
// Revision 1.2  2008/03/13 16:15:50  lenz
// Primo giro minimanete funzionante.
//
// Revision 1.1  2008/03/11 18:21:54  lenz
// Primo check-in - solo come segnaposto.
//
//
//
//
%>
