<%@ page language="java" %>
<%@ page import="it.loway.tpf.*" %>
<%@ page import="it.loway.tpf.common.containers.*" %>
<%@ page import="it.loway.tpf.common.interfaces.*" %>
<%@ page import="it.loway.tpf.common.exceptions.*" %>
<%@ page import="it.loway.tpf.presentation.html.*" %>
<%@ page import="it.loway.app.queuemetrics.smartTableDecorators.*" %>
<%@ include file="/includes/00_page_header.jspf" %>
<%
    //$Id: storage_info.jsp,v 1.9 2015/09/28 08:41:15 marcos Exp $
    class buttonDetailDecor implements TpfCellDecoratorInterface {
            HtmlGenerator obH = null;
            public buttonDetailDecor( HtmlGenerator oH  ) { obH = oH; };
            public String decorate(LTable lt, int r, int c, String width) throws TechException {
                String stTesto = lt.getS(r, c );
                String stButt = obH.button( "Info", true, "", "qm_mysqlStorageInfo_run", stTesto );
                stButt += " " + obH.button( "Autocfg", true, "", "qm_mysqlStorageInfo_createq", stTesto );
                return  "  <td class='stData' style='width: " + width + ";'><div class='L-row L-gap-16'>" + stButt + "</div></td>\n";
            }
    };

    class intNumDecor implements TpfCellDecoratorInterface {
            public String decorate(LTable lt, int r, int c, String width) throws TechException {
                int val = lt.getI(r, c );
                String stD = U.formattaNumero( val, 0 );
                return  "  <td class='stData' style='width: " + width + ";' align='right'>" + stD+ "</td>\n";
            }
    };

    class tstToFullDateDecor implements TpfCellDecoratorInterface {
    	public String decorate(LTable lt, int r, int c, String width) throws TechException {
                    int inTstUnix = lt.getI(r, c );
                    return  "  <td class='stData' style='width: " + width + ";'> &nbsp; " + U.gtData( "yyyy-MM-dd MM:mm", new Date( inTstUnix * 1000L)  ) + " </td>\n";
    	}
    }

    class daysDecor implements TpfCellDecoratorInterface {
    	public String decorate(LTable lt, int r, int c, String width) throws TechException {
                    int inTstUnix1 = lt.getI(r, c );
                    int inTstUnix2 = lt.getI(r, c+1 );
                    float nDays = ((float)( inTstUnix2 - inTstUnix1 )) / ( 24*3600) ;
                    return  "  <td class='stData' style='width: " + width + ";' align='right'> " + U.formattaNumero( nDays, 1) + " days </td>\n";
    	}
    }
%>

<script>
function onLoadApplicativo() {

	// transazione standard
	document.forms[0].<%= K.REQ_VERBO %>.value = "";
	document.forms[0].<%= K.REQ_PARAM %>.value = "";

  if ( "<%= oC.getS("STORAGE_transaction") %>".length > 0 ) {
      setTimeout( "reloadpage()", 100 );
  }
}

function reloadpage() {
    document.location.href = "<%= oC.getS("STORAGE_transaction") %>" + ".do";
}
</script>

<div class="qm-form-body L-column L-gap-16">
    <h1>Current storage info</h1>
        Total number of rows in table: <%= U.formattaNumero( oC.getI( "STORAGE_nlines" ), 0 ) %> <br><br>
        Total table space: <%= U.formattaNumero( ((oC.getI( "STORAGE_bytes" ) + oC.getI( "STORAGE_bytesIndex" )) / (1024.0  ) ), 1) %>  M
        ( Data: <%= U.formattaNumero( (oC.getI( "STORAGE_bytes" ) / (1024.0  ) ) , 1 ) %> M -
        Indexes:  <%= U.formattaNumero( (oC.getI( "STORAGE_bytesIndex" ) / (1024.0  )), 1 )  %> M )
    <p>
    <%
        if ( oC.defined( "STORAGE_transaction" )) {
    %>
    <h2><font color="red">The data is now being fetched from the database... this might take a while.</font></h2>
    <%
        } else {
    %>
    <%
    LTable ltConf = oC.getLt("STORAGE_partitions");
    SmartTable T = new SmartTable( "x", ltConf );
    T.setDecoder( oDec );
    T.addColumn( "Partition",       0, "100px" );
    T.addColumn( "Entries",         1,  "70px" , new intNumDecor() );
    T.addColumn( "N. calls",        4,  "70px" , new intNumDecor() );
    T.addColumn( "From:",           5, "120px", new tstToFullDateDecor()  );
    T.addColumn( "To:",             6, "120px", new tstToFullDateDecor()  );
    T.addColumn( "Days of data:",   5,  "90px", new daysDecor()  );
    T.addColumn( "Last heartbeat:", 2, "120px", new tstToFullDateDecor()  );
    T.addColumn( "&nbsp;", 0, "140px", new buttonDetailDecor( oH )  );

    T.withTableClass( "qm-table uk-table uk-table-small uk-table-divider uk-table-striped uk-table-hover uk-width-expand" );
    out.println(T.render());
    %>

    <br>

    <div class="L-justify-flexstart">
        <%= oH.button( "Autoconfigure hidden queues from all partitions", true, "", "qm_mysqlStorageInfo_createq", "" ) %>
    </div>
    <p>
    <i>Note: the "Number of Calls" shown here is meant as a rough estimate and may differ from the
    one actually shown by the reports.</i>
    <p>

    <% if ( oC.defined( "STORAGE_detail" ) ) { %>
    <h1>Details for partition: <%= oC.getS( "STORAGE_detail" ) %> </h1>
    N. rows in partition: <%= U.formattaNumero( oC.getI( "STORAGE_detail_nrows" ), 0 ) %>
    <p>
    <h2>Queues:</h2>
    <%
        T = new SmartTable( "x", oC.getLt( "STORAGE_detail_queues" ) );
        T.setDecoder( oDec );
        T.addColumn( "Queue",      0, "150px" );
        T.addColumn( "Entries",    1,  "70px", new intNumDecor()  );
        T.addColumn( "From:",      2, "120px", new tstToFullDateDecor()  );
        T.addColumn( "To:",        3, "120px", new tstToFullDateDecor()  );
        T.addColumn( "Days:",      2,  "90px", new daysDecor()  );

        T.withTableClass( "qm-table uk-table uk-table-small uk-table-divider uk-table-striped uk-table-hover uk-width-expand" );
        out.println(T.render());
    %>
    <p>
    <h2>Agents:</h2>
    <%
        T = new SmartTable( "x", oC.getLt( "STORAGE_detail_agents" ) );
        T.setDecoder( oDec );
        T.addColumn( "Agent",      0, "150px" );
        T.addColumn( "Entries",    1,  "70px", new intNumDecor() );
        T.addColumn( "From:",      2, "120px", new tstToFullDateDecor()  );
        T.addColumn( "To:",        3, "120px", new tstToFullDateDecor()  );
        T.addColumn( "Days:",      2,  "90px", new daysDecor()  );
        T.withTableClass( "qm-table uk-table uk-table-small uk-table-divider uk-table-striped uk-table-hover uk-width-expand" );
        out.println(T.render());
    %>
    <% }; %>
    <% if ( oC.getLt( "STORAGE_autodefqueues" ).numRows() > 0 ) { %>
    <h1>Queue autoconfiguration</h1>
    <%
        T = new SmartTable( "x", oC.getLt( "STORAGE_autodefqueues" ) );
        T.setDecoder( oDec );
        T.addColumn( "Partition",      0, "150px" );
        T.addColumn( "Queue",          1, "150px");
        T.addColumn( "Activity",       2, "300px" );
        T.withTableClass( "qm-table uk-table uk-table-small uk-table-divider uk-table-striped uk-table-hover uk-width-expand" );
        out.println(T.render());
    %>
    <% }; %>
    <% }; %>
</div>

<%@ include file="/includes/00_page_footer.jspf" %>

<%
// $Log: storage_info.jsp,v $
// Revision 1.9  2015/09/28 08:41:15  marcos
// jsp/jspf refactoring.
//
// Revision 1.8  2014/05/19 09:46:37  lenz
// Merge FRANKIE
//
// Revision 1.7.12.1  2014/05/13 13:33:33  mirkox
// Nuova Grafica
//
// Revision 1.7  2009/01/21 14:20:54  lenz
// Bug #616: lettura dettagli dello storage.
//
// Revision 1.6  2008/12/04 11:41:30  lenz-mobile
// Bug #560 - page not working in Opera.
//
// Revision 1.5  2007/11/17 14:25:34  lenz
// Bug #234 - Layout decente.
//
// Revision 1.4  2007/11/17 13:54:42  lenz
// Bug #234: Creazione automatica code nascoste.
//
// Revision 1.3  2007/06/22 07:27:19  lenz
// Bug #151: non si vedeva correttamente la dimesione per tabelle > 2Gb
//
// Revision 1.2  2007/02/18 21:23:19  lenz
// - Caricamento a due passaggi.
// - Formattazione dei dati leggibile.
//
// Revision 1.1  2007/02/17 19:01:01  lenz
// Gestione Storage Info
//
//
//
//
%>
