<%@ page language="java" %>
<%@page isErrorPage="true" %>
<%@ page import="it.loway.tpf.*" %>
<%@ page import="it.loway.tpf.common.containers.*" %>
<%@ page import="it.loway.app.queuemetrics.html.NoCache" %>
<%@ page import="it.loway.app.queuemetrics.*" %>
<%@ page import="ch.loway.app.queuemetrics.KnownUrls" %>
<%@include file="/includes/00_page_header_context.jspf" %>
<%

// Gestione errori:
// esistono vari tipi di errori, a seconda che facciano parte di una lista
// o di altre liste
// Gli errori SESS sono di sessione e semplicemente ritornano a index.jsp
// Gli errori JDBC noti puntano alle FAQ
// Gli errori DISK dicono che il disco di MySQL e' pieno o non scrivibile
// Gli altri errori sono mostrati semplicemente
//....

    // Legge l'errore dal contesto
    //
    LErrors err = (LErrors) session.getAttribute( K.SESSION_ERRORI );
    String stMyUserName = "";
    String stPlexId     = "";
    if ( exception != null ) {
            stErr = "[JSP] " + exception.getClass().getName() + " - " + U.stringifyException( exception );
        } else {

            if ( err != null ) {
                stErr = err.getError();
                stMyUserName = err.getCurrentUserLicence();
                stPlexId     = err.getPlexId();
            }
        }

    if ( stErr == null ) {
        stErr = "*** No error detected ***";
    }

    err = null;
    session.removeAttribute(K.SESSION_ERRORI );


    // prova a leggere l'errore


    // tipizza l'errore
    stErr = U.subst(stErr, "\"", "'");
    String stErrType = FA.errorType( stErr );
    boolean boRestartAutomatico = false;
    boolean boRestartJdbc       = false;
    boolean boMostraMsgErr      = true;
    boolean boNotificaErrore    = true;
    boolean boMostraLinkFAQ     = true;
    String  stErrExpl           = "";

    if ( stErrType.equalsIgnoreCase( "SESS" ) || stErr.length() == 0 ) {
        boRestartAutomatico = true;
        boMostraMsgErr      = false;
        boNotificaErrore    = false;
        boMostraLinkFAQ     = false;
        stErrExpl           = "Your user session has expired. The webapp will restart automatically in a few seconds.";
    } else
    if ( stErrType.equalsIgnoreCase( "JDBC" ) ) {
        boRestartAutomatico = false;
        boRestartJdbc       = true;
        boMostraMsgErr      = true;
        boNotificaErrore    = true;
        boMostraLinkFAQ     = true;
        stErrExpl           = "The connection to MySQL does not seem to be working correctly.";
    } else
    if ( stErrType.equalsIgnoreCase( "DISK" ) ) {
        boRestartAutomatico = false;
        boMostraMsgErr      = true;
        boNotificaErrore    = true;
        boMostraLinkFAQ     = true;
        stErrExpl           = "The MySQL server is having problems because its disk is full or non-writable.";
    }

    boolean isWhiteLabel = KnownUrls.isWhitelabel();



%>



<head>
<meta http-equiv="Content-Type" content="text/html; charset=<%= K.ENCODING_UTF8 %>" />
<title>A problem occurred</title>
<meta name="keywords" content="" />
<meta name="description" content="" />
<%= NoCache.importJsTheme(request, oC, "/img/js-bundle/", "bundle-qmplain.js", "bundle-commons-react.js","bundle-commons-all.js") %>
<%= NoCache.importCssTheme(request, oC, "/img/js-bundle/", "commons-all.css", "screen,projection" ) %>
<%= NoCache.favicon( request, oC) %>

</head>
<body id="xBody" onload="">


<div id="xPanel">


  <!-- start -->
  <div class="qm-header">

    <div class="qm-logo" onclick="myhref('<%=stWebHere%>')" title="<%=oDec.k("hdr_qmlogo_returntohomelink")%>" >
    </div>  

    <!-- customer logo -->
    <div class="error-page-qm-logo-customer">
        <img src="<%= lP.getLogo() %>" />
    </div>
  </div>

<!-- end -->
<div id="xMenu1">
<table border="0" cellspacing="0" cellpadding="0" width="100%" class="menu1">
<tr>
<td id="first"> &nbsp; </td>
<td width="99%" id="last">&nbsp;</td>
</tr>
</table>

</div>

<div id="xCorpo">
<center>
<h1>A problem occurred in <%=CS.QUEUEMETRICS%>.</h1>

<p>

<%
    if (boMostraMsgErr) {
%>
<P>
<b>The following error occurred in the Transaction handler:</b><br>

<table border="1" cellpadding="5">
<tr><td>

<%= lP.safeLogError( stErr ) %>

</td></tr>
<%
    if ( stErrExpl.length() > 0 ) {
%>
<tr><td>
<b>Root cause:</b> <%= stErrExpl %>
</td></tr>
<%
    };
%>

<tr><td>
System time when the error occurred: <%= U.gtDataOdierna( U.DATA_TIMESTAMP ) %>
</td></tr>
</table>

<p>
<b>Please contact your system administrator with a printout of the error above to address the problem.</b>
<%
    } else {
%>
<%=  stErrExpl %>
<%
    };
%>

<%
    if ( boMostraLinkFAQ && !isWhiteLabel) {
%>
<p>
A list of common error causes and their resolutions can be found at
<%= KnownUrls.linkQmFAQ() %>.
<p>
If you think that your problem is related to JDBC or MySQL, try the online <a href="<%= stWebHere %>/dbtest">JDBC Connection tester</a>.
<p>
If you need help in running <%=CS.QUEUEMETRICS%>, feel free to
<%= KnownUrls.linkContactUs() %>.


<%
    };
%>

<% // notifica automagica %>
<%
    if ( boNotificaErrore ) {
%>
<iframe src="<%= K.URL_NOTIFY_ERR %>?D_A=<%= Str.urlencode(KA.NOME_APPLICAZIONE) %>&D_V=<%= Str.urlencode(KA.APPL_VERSIONE) %>&D_L=<%= Str.urlencode(stMyUserName) %>&D_P=<%= Str.urlencode(stPlexId) %>&D_E=<%= Str.urlencode(stErr) %>" class="error_frame"></iframe>

<%
    };
%>

<p>
&nbsp;
<p>

<INPUT TYPE='button'
    CLASS='Q-button-primary'
    VALUE="Restart now &raquo; "
    onClick="location.href='qm_start.do'"
     >

<%
    // timer automatico
    if ( boRestartAutomatico ) {
%>
<script defer>
    setTimeout( "location.href='qm_start.do'", 5 * 1000 );
</script>
<%
    };
%>

<%
    // timer JDBC
    if ( boRestartJdbc) {
%>
<script >
    window.location.href='./dbtest/invalid_db.jsp'
    // setTimeout( "location.href='./dbtest/invalid_db.jsp'", 5 * 1000 );
</script>
<%
    };
%>


</center>


<p>
&nbsp;
<p>

&nbsp;
<p>








<p>
&nbsp;
<p>
</div>

<%@ include file="./includes/00_footer.jspf" %>

</div>
</body>
</html>

<%
    // termina in ogni caso la sessione corrente....
    //session.invalidate();
%>
