<%@ page language="java" %>
<%@ page isErrorPage="true" %>
<%@ page import="it.loway.tpf.*" %>
<%@ page import="it.loway.tpf.common.containers.*" %>
<%@ page import="it.loway.app.queuemetrics.*" %>
<%@ page import="it.loway.app.queuemetrics.html.NoCache" %>
<%@ page import="org.slf4j.Logger" %>
<%@ page import="org.slf4j.LoggerFactory"  %>
<%@page contentType="text/html;charset=UTF-8"%>
<%@page pageEncoding="UTF-8"%>
<%@include file="/includes/00_page_header_context.jspf" %>

<%
    stErr = "";
    if (exception != null) {
            stErr = "[JSP] " + exception.getClass().getName() + " - " + U.stringifyException( exception );
    }

    // web corrente
    stWebHere = Web.getWebApp( request );

    final Logger logger = LoggerFactory.getLogger("PageFooter");
    logger.error(stErr);
%>

<head>
<meta http-equiv="Content-Type" content="text/html; charset=<%= K.ENCODING_UTF8 %>" />
<title>A problem occurred</title>
<meta name="keywords" content="" />
<meta name="description" content="" />

<%= NoCache.importJsTheme(request, oC, "/img/js-bundle/", "bundle-qmplain.js", "bundle-commons-react.js", "bundle-commons-all.js") %>
<%= NoCache.importCssTheme(request, oC, "/img/js-bundle/", "commons-all.css", "screen,projection" ) %>
<%= NoCache.favicon( request, oC) %>


</head>
<body id="xBody" onload="">
<div id="xPanel">

    <!-- start -->
    <div class="qm-header L-row L-justify-spacebetween">
      <%if (oU.userLoggedOn()) {%>
        <div class="qm-logo" onclick="myhref('<%=stWebHere%>')" title="<%=oDec.k("hdr_qmlogo_returntohomelink")%>" >
        </div>  
      <%} else {%>
        <div class="<%= lP.securedString( "qm-logo", "") %>" onclick="myhref('<%= lP.securedString( stWebHere , "" ) %>')" title="<%=oDec.k("hdr_qmlogo_returntohomelink")%>" >
        </div>
      <%}%>
  
      <!-- customer logo -->
      <div class="error-page-qm-logo-customer">
        <img src="<%= lP.getLogo() %>" />
      </div>
    </div>

  <!-- end -->

<div id="xMenu1">
  <table border="0" cellspacing="0" cellpadding="0" width="100%" class="menu1">
  <tr>
  <td id="first"> &nbsp; </td>
  <td width="99%" id="last">&nbsp;</td>
  </tr>
  </table>
</div>



<div id="xCorpo">

<center>
<div class="L-column L-gap-16">

  <h1>A problem occurred in <%=CS.QUEUEMETRICS%>.</h1>
  
  <b>The following error occurred in the Transaction handler:</b>
    <div class="uk-table">
      <table border="1" cellpadding="5">
        <tr><td>
          <%= lP.safeLogError( stErr ) %>
        </td></tr>
        <tr><td>
          System time when the error occurred: <%= U.gtDataOdierna( U.DATA_TIMESTAMP ) %>
        </td></tr>
      </table>
    </div>
    
    <p>
      <b>Please contact your system administrator with a printout of the error above to address the problem.</b>
    </p>
    <div>
      A list of common error causes and their resolutions can be found at
      <a href="<%=CS.QM_WEBSITE%>/faq.jsp?from=qm-<%= KA.APPL_VERSIONE %>" target="qm"><%=CS.QM_WEBSITE%>/faq.jsp</A>.
    </div>
      If you think that your problem is related to JDBC or MySQL, try the online <a href="<%= stWebHere %>/dbtest">JDBC Connection tester</a>
    <div>
      If you need help in running <%=CS.QUEUEMETRICS%>, feel free to
      <a href="<%=CS.QM_WEBSITE%>/contact.jsp?from=qm-<%= KA.APPL_VERSIONE %>" target="qm">contact us</A>.     
    </div>  
    <p>
      &nbsp;
    <p>
                    
    <INPUT TYPE='button'
    CLASS='Q-button-primary'
    VALUE="Restart now &raquo; "
    onClick="location.href='qm_start.do'"
    >
</div>

<script defer>
  setTimeout( "location.href='qm_start.do'", 5 * 1000 );
</script>

</center>


<p>
&nbsp;
<p>

&nbsp;
<p>

<p>
&nbsp;
<p>

</div>

<%@ include file="./includes/00_footer.jspf" %>

</div>

</body>
</html>
